DEFINT A-Z

DECLARE SUB CalcAttr (BYVAL ForeGround, BYVAL BackGround, Attr)
DECLARE SUB UnCalcAttr (ForeGround, BackGround, BYVAL Attr)
DECLARE SUB SpeedKey (BYVAL RepDeley, BYVAL RepRate)

DECLARE SUB DMPrint (St$)

DECLARE SUB FCreate (FileName$, BYVAL Attr, FileHandle, ErrCode)
DECLARE SUB FClose (BYVAL FileHandle)
DECLARE SUB DFWrite (BYVAL FileHandle, BYVAL DSeg, BYVAL DOfs, BYVAL Bytes, BytesWrit, ErrCode)
DECLARE SUB DFRead (BYVAL FileHandle, BYVAL DSeg, BYVAL DOfs, BYVAL Bytes, BytesRead, ErrCode)
DECLARE FUNCTION GetSub2$ (Drive$)
DECLARE SUB ParseFSpec (FileSpec$, Drive$, DLen, SubDir$, SLen, File$, FLen)
DECLARE SUB SetDrv (Drive$)
DECLARE SUB SetSub (SubDir$, ErrCode%)
DECLARE SUB Exist (FileName$, Found)
DECLARE FUNCTION GetDrive$ ()
DECLARE SUB Rename (CurrentName$, NewName$, ErrCode)

DECLARE SUB GetCRT (ColorDisplay)
DECLARE SUB DelLine (BYVAL row, BYVAL Attr)
DECLARE SUB InsLine (BYVAL row, BYVAL Attr)
DECLARE SUB DReColor (BYVAL DSeg, BYVAL DOfs, BYVAL OldAttr, BYVAL CCA)
DECLARE SUB DReColorArea (BYVAL DSeg, BYVAL DOfs, BYVAL row, BYVAL col, BYVAL BottomRow, BYVAL RightCol, BYVAL CCA)
DECLARE SUB LScroll (BYVAL TopRow, BYVAL LeftCol, BYVAL BottomRow, BYVAL RightCol, BYVAL Times)
DECLARE SUB RScroll (BYVAL TopRow, BYVAL LeftCol, BYVAL BottomRow, BYVAL RightCol, BYVAL Times)
DECLARE SUB BkScroll (BYVAL TopRow, BYVAL LeftCol, BYVAL BottomRow, BYVAL RightCol, BYVAL Times)
DECLARE SUB Scroll (BYVAL TopRow, BYVAL LeftCol, BYVAL BottomRow, BYVAL RightCol, BYVAL Times)

DECLARE SUB ScrSave (ScreenSaved(), Page, Fast)
DECLARE SUB ScrRest (ScreenSaved(), Page, Fast)

DECLARE SUB FindFirstF (File$, BYVAL Attribute, ErrCode)
DECLARE SUB FindNextF (ErrCode)
DECLARE SUB GetNameF (File$, NameLen)
DECLARE SUB GetAttrF (Attr)
DECLARE SUB SetFAttr (FileName$, BYVAL Attr)

DECLARE SUB KeyHit (a$)
DECLARE SUB SetAttr (Attr)
DECLARE SUB FileNotSaved ()
DECLARE SUB EndProgram ()
DECLARE SUB SaveFile ()
DECLARE SUB SetTab (TabSpace)
DECLARE SUB LoadFile ()
DECLARE SUB ReColorText (row, col, PCol)
DECLARE SUB Help ()
DECLARE SUB Info (ESC)
DECLARE SUB ChangeFileName (FileName$)
DECLARE SUB FillScreen ()
DECLARE SUB SetKeySpeed ()
DECLARE SUB StringScroll (Strg$, StrgStart%, StrgRow%, ScrlTime%, StrgPause%, StrgWrap%, StrgPasses%, StrgStopLoc%, StrgMultCol%, StrgBackCol%, ExitKey$)


COMMON SHARED Attr, Format$, HeartCode(), ActHeartCode$(), NotSave
COMMON SHARED FileName$, SavedScreen(), FileSpec$, AnsiCode$()
COMMON SHARED AnsActAttr(), ToggleScreen(), FileError



REDIM InsAttr(1 TO 81), InsChar(1 TO 81), AnsActAttr(1 TO 255)
REDIM AnsiCode$(1 TO 255), HeartCode(1 TO 37), ActHeartCode$(1 TO 37)
REDIM SavedScreen(1 TO 2000), SavedScreen2(1 TO 2000), ToggleScreen(1 TO 2000)
REDIM File2$(1 TO 50)

CLS

DEF SEG = 0


GetCRT ColorDisplay



' Initialize the HeartCode Array
FOR i = 1 TO 36
    READ HeartCode(i)
    READ ActHeartCode$(i)
NEXT i

' Initialize AnsiCode Array
FOR i = 1 TO 144
    READ AnsActAttr(i)
    READ AnsiCode$(i)
NEXT i


' Check for Mono or Color Monitor and set Segment to the
' required screen memory location (Color = 47104 | Mono = 45056).
IF ColorDisplay THEN
   MonitorType& = 47104
ELSE
    MonitorType& = 45056
END IF
DEF SEG = MonitorType&


' Initialize some variables.
Attr = 7: row = 12: col = 40: PCol = 1838: INS = 0: FileName$ = "  No Name!"
TabSpace = 5: FileSpec$ = "*.*": Format$ = "Ascii": x = 1: ScreenPage = 1
Pg = 1: Func = 1


SpeedKey 0, 8

GOSUB InitializeStatusBar
GOSUB Status
GOSUB TitleScreen
GOSUB DisplayFunction
IF Format$ = "Heart" THEN Attr = 7

'*****************************************************************************
KeyProcess:

GOSUB Status

KeyHit a$

' Cursor Left
IF a$ = CHR$(0) + CHR$(75) THEN
    PCol = PCol - 2
    IF PCol < 0 THEN PCol = 0
    col = col - 1
    IF row <= 1 AND col <= 1 THEN row = 1: col = 1
    IF col < 1 THEN row = row - 1: col = 80
    IF row < 1 THEN row = 1
    GOTO KeyProcess
END IF

' Cursor Right
IF a$ = CHR$(0) + CHR$(77) THEN
    PCol = PCol + 2
    IF PCol > 3838 THEN PCol = 3838
    col = col + 1
    IF row >= 24 AND col >= 80 THEN row = 24: col = 80
    IF col > 80 THEN row = row + 1: col = 1
    IF row > 24 THEN row = 24
    GOTO KeyProcess
END IF

' Cursor Down
IF a$ = CHR$(0) + CHR$(80) THEN
      IF row > 23 THEN row = 24: GOTO KeyProcess
      PCol = PCol + 160
      row = row + 1
      GOTO KeyProcess
END IF

' Cursor Up
IF a$ = CHR$(0) + CHR$(72) THEN
      IF row < 2 THEN row = 1: GOTO KeyProcess
      PCol = PCol - 160
      row = row - 1
      GOTO KeyProcess
END IF


' The TAB Key
IF a$ = CHR$(9) THEN
   col = col + TabSpace
   IF col > 80 THEN col = col - TabSpace: GOTO KeyProcess
   PCol = PCol + (TabSpace * 2)
   GOTO KeyProcess
END IF


' Set TAB Space [ALT-T]
IF a$ = CHR$(0) + CHR$(20) THEN
     SetTab TabSpace
     GOSUB InitializeStatusBar
END IF

    

' BACKSPACE Key
IF a$ = CHR$(8) THEN
    b$ = "": c = 0
    FOR i = PCol TO PCol + ((80 - col) * 2) STEP 2
        c = c + 1
        b$ = b$ + CHR$(PEEK(i))
        InsChar(c) = PEEK(i)
        InsAttr(c) = PEEK(i + 1)
    NEXT i
   
    col = col - 1
    IF col < 1 THEN col = 1: GOTO 3
    PCol = PCol - 2
3   IF PCol < 0 THEN PCol = 0
    POKE PCol, 32
    b$ = RTRIM$(b$)
    c = 0
    FOR i = 1 TO LEN(b$)
        POKE PCol + c, InsChar(i)
        POKE PCol + (c + 1), InsAttr(i)
        POKE PCol + (LEN(b$) * 2), 32: POKE PCol + ((LEN(b$) * 2) + 1), Attr
        c = c + 2
    NEXT i
    GOTO KeyProcess
END IF


' Delete Characters [DELETE]
IF a$ = CHR$(0) + CHR$(83) THEN
    b$ = "": c = 0
    FOR i = PCol TO PCol + ((80 - col) * 2) STEP 2
        c = c + 1
        b$ = b$ + CHR$(PEEK(i))
        InsChar(c) = PEEK(i)
        InsAttr(c) = PEEK(i + 1)
    NEXT i
    POKE PCol, 32: POKE PCol + 1, Attr

    b$ = RTRIM$(b$)
    c = 0
    FOR i = 2 TO LEN(b$) + 1
        POKE PCol + c, InsChar(i)
        POKE PCol + (c + 1), InsAttr(i)
        POKE PCol + (LEN(b$) * 2), 32: POKE PCol + ((LEN(b$) * 2) + 1), Attr
        c = c + 2
    NEXT i
    LOCATE row, col
    GOTO KeyProcess
END IF


' Delete a Line [ALT -]
IF a$ = CHR$(0) + CHR$(130) THEN
    LOCATE 25, 1: COLOR 7, 0
    PRINT "                                                                                ";
    LOCATE row, col
    SOUND 2500, .5
    DelLine row, 7
    GOSUB InitializeStatusBar
    GOSUB DisplayFunction
    NotSave = 1
    GOTO KeyProcess
END IF


' Page Up - Change Attribute (Scroll Up numbers)
IF a$ = CHR$(0) + CHR$(73) THEN
    IF INSTR("Ansi Ascii", Format$) > 0 THEN
            Attr = Attr + 1
            IF Attr > 254 THEN Attr = 254
            GOTO KeyProcess
    ELSE
    x = x + 1
    IF x > 36 THEN x = 36
    Attr = HeartCode(x)
    GOTO KeyProcess
    END IF
END IF


' Page Down - Change Attribute (Scroll Dwn numbers)
IF a$ = CHR$(0) + CHR$(81) THEN
    IF INSTR("Ansi Ascii", Format$) > 0 THEN
            Attr = Attr - 1
            IF Attr < 0 THEN Attr = 0
            GOTO KeyProcess
    ELSE
    x = x - 1
    IF x < 1 THEN x = 1
    Attr = HeartCode(x)
    GOTO KeyProcess
    END IF
END IF


' ENTER Key
IF a$ = CHR$(13) THEN
    IF PCol < 3680 THEN PCol = PCol + ((80 - col) * 2) + 2
    row = row + 1: col = 1
    GOSUB CheckRowCol
    GOTO KeyProcess
END IF


' Clear the Screen
IF a$ = CHR$(0) + CHR$(46) THEN
    GOSUB ClearScreen
    GOSUB InitializeStatusBar
    GOSUB DisplayFunction
    GOTO KeyProcess
END IF


' Home the Cursor in upper left corner [CNTL-Home]
IF a$ = CHR$(0) + CHR$(119) THEN
    PCol = 0: row = 1: col = 1
    GOTO KeyProcess
END IF


' Home the Cursor to beginning of Current Row. [Home]
IF a$ = CHR$(0) + CHR$(71) THEN
    PCol = PCol - (col * 2) + 2
    col = 1
    GOTO KeyProcess
END IF


' INSERT Key
IF a$ = CHR$(0) + CHR$(82) THEN
         IF flag1 = 0 THEN flag1 = 1: INS = 1 ELSE flag1 = 0: INS = 0
         IF flag1 = 0 THEN LOCATE , , 1, 7, 7
         IF flag1 = 1 THEN LOCATE , , 1, 4, 7
         GOTO KeyProcess
END IF


' Insert a Line [ALT =]
IF a$ = CHR$(0) + CHR$(131) THEN
    SOUND 2500, .5
    InsLine row, 7
    GOSUB InitializeStatusBar
    GOSUB DisplayFunction
    NotSave = 1
    GOTO KeyProcess
END IF


' END Key
IF a$ = CHR$(0) + CHR$(79) THEN GOSUB GoToEndOfLine: GOTO KeyProcess


' Scroll Screen Left [CTRL - Left Arrow]
IF a$ = CHR$(0) + CHR$(115) THEN
    REDIM ScreenArray(1 TO 50)
    b = 1: j = 1
    FOR a = 1 TO 24
       CharOff = (a - 1) * 160 + (b - 1) * 2
       AttrOff = ((a - 1) * 160 + (b - 1) * 2) + 1
       ScreenArray(j) = PEEK(CharOff)
       j = j + 1
       ScreenArray(j) = PEEK(AttrOff)
       j = j + 1
    NEXT a
    SOUND 2500, .5
    LScroll 1, 1, 24, 80, 1
    b = 80: j = 1
    FOR a = 1 TO 24
       CharOff = (a - 1) * 160 + (b - 1) * 2
       AttrOff = ((a - 1) * 160 + (b - 1) * 2) + 1
       POKE CharOff, ScreenArray(j)
       j = j + 1
       POKE AttrOff, ScreenArray(j)
       j = j + 1
    NEXT a
    ERASE ScreenArray
    GOSUB InitializeStatusBar
    GOSUB DisplayFunction
    NotSave = 1
    GOTO KeyProcess
END IF


' Scroll Screen Right [CTRL - Right Arrow]
IF a$ = CHR$(0) + CHR$(116) THEN
    REDIM ScreenArray(1 TO 50)
    b = 80: j = 1
    FOR a = 1 TO 24
       CharOff = (a - 1) * 160 + (b - 1) * 2
       AttrOff = ((a - 1) * 160 + (b - 1) * 2) + 1
       ScreenArray(j) = PEEK(CharOff)
       j = j + 1
       ScreenArray(j) = PEEK(AttrOff)
       j = j + 1
    NEXT a
    SOUND 2500, .5
    RScroll 1, 1, 24, 80, 1
    b = 1: j = 1
    FOR a = 1 TO 24
       CharOff = (a - 1) * 160 + (b - 1) * 2
       AttrOff = ((a - 1) * 160 + (b - 1) * 2) + 1
       POKE CharOff, ScreenArray(j)
       j = j + 1
       POKE AttrOff, ScreenArray(j)
       j = j + 1
    NEXT a
    ERASE ScreenArray
    GOSUB InitializeStatusBar
    GOSUB DisplayFunction
    NotSave = 1
    GOTO KeyProcess
END IF


'Scroll the Screen Down [CTRL - Page Down]
IF a$ = CHR$(0) + CHR$(118) THEN
    REDIM ScreenArray(1 TO 170)
    a = 24: j = 1
    FOR b = 1 TO 80
       CharOff = (a - 1) * 160 + (b - 1) * 2
       AttrOff = ((a - 1) * 160 + (b - 1) * 2) + 1
       ScreenArray(j) = PEEK(CharOff)
       j = j + 1
       ScreenArray(j) = PEEK(AttrOff)
       j = j + 1
    NEXT b
    SOUND 2500, .5
    BkScroll 1, 1, 24, 80, 1
    a = 1: j = 1
    FOR b = 1 TO 80
       CharOff = (a - 1) * 160 + (b - 1) * 2
       AttrOff = ((a - 1) * 160 + (b - 1) * 2) + 1
       POKE CharOff, ScreenArray(j)
       j = j + 1
       POKE AttrOff, ScreenArray(j)
       j = j + 1
    NEXT b
    ERASE ScreenArray
    GOSUB InitializeStatusBar
    GOSUB DisplayFunction
    NotSave = 1
    GOTO KeyProcess
END IF


'Scroll the Screen UP [CTRL - Page Up]
IF a$ = CHR$(0) + CHR$(132) THEN
    REDIM ScreenArray(1 TO 170)
    a = 1: j = 1
    FOR b = 1 TO 80
       CharOff = (a - 1) * 160 + (b - 1) * 2
       AttrOff = ((a - 1) * 160 + (b - 1) * 2) + 1
       ScreenArray(j) = PEEK(CharOff)
       j = j + 1
       ScreenArray(j) = PEEK(AttrOff)
       j = j + 1
    NEXT b
    SOUND 2500, .5
    Scroll 1, 1, 24, 80, 1
    a = 24: j = 1
    FOR b = 1 TO 80
       CharOff = (a - 1) * 160 + (b - 1) * 2
       AttrOff = ((a - 1) * 160 + (b - 1) * 2) + 1
       POKE CharOff, ScreenArray(j)
       j = j + 1
       POKE AttrOff, ScreenArray(j)
       j = j + 1
    NEXT b
    ERASE ScreenArray
    GOSUB InitializeStatusBar
    GOSUB DisplayFunction
    NotSave = 1
    GOTO KeyProcess
END IF


' Toggle View Screen and Main Screen. [ALT-N]
IF a$ = CHR$(0) + CHR$(49) THEN
      ScrSave SavedScreen(), 0, 1
      ScrRest ToggleScreen(), 0, 1
      KeyHit a$
      ScrRest SavedScreen(), 0, 1
      GOTO KeyProcess
END IF


' Set Colors (Attributes)  [ALT-A]
IF a$ = CHR$(0) + CHR$(30) THEN
      SetAttr Attr
      COLOR 7, 1
      GOSUB InitializeStatusBar
      GOSUB Status
      GOSUB DisplayFunction
      GOTO KeyProcess
END IF


' Re-Color ALL or PART of text from one color to another. [ALT-R]
IF a$ = CHR$(0) + CHR$(19) THEN
    ReColorText row, col, PCol
    GOSUB InitializeStatusBar
    GOSUB DisplayFunction
    GOTO KeyProcess
END IF


' Fill Screen With a specific Attribute [ALT-F]
IF a$ = CHR$(0) + CHR$(33) THEN
     FillScreen
     GOSUB InitializeStatusBar
     'GOSUB Status
     GOSUB DisplayFunction
     GOTO KeyProcess
END IF



' Toggle Formats [ALT-Y]
IF a$ = CHR$(0) + CHR$(21) THEN
      IF flag2 = 2 THEN flag2 = 0: Format$ = "Ascii": GOTO 7
      IF flag2 = 1 THEN flag2 = 2: Format$ = "Heart"
      IF flag2 = 0 THEN flag2 = 1: Format$ = "Ansi"
7     GOTO KeyProcess
END IF


'Save File [ALT-S]
IF a$ = CHR$(0) + CHR$(31) THEN
     SaveFile
     GOSUB InitializeStatusBar
     GOSUB DisplayFunction
     GOTO KeyProcess
END IF


' Load File [ALT-L]
IF a$ = CHR$(0) + CHR$(38) THEN
     LoadFile
     GOSUB InitializeStatusBar
     GOSUB DisplayFunction
     row = 12: col = 40: PCol = 1838
     GOTO KeyProcess
END IF


' Select Graphic Characters [SHIFT F1 to SHIFT F10].
IF a$ > CHR$(0) + CHR$(83) AND a$ < CHR$(0) + CHR$(94) THEN
        GOSUB Functions
        GOTO KeyProcess
END IF


' Exit VDDRAW - [ESCAPE]
IF a$ = CHR$(27) THEN
     EndProgram
     GOSUB InitializeStatusBar
     GOSUB DisplayFunction
     GOTO KeyProcess
END IF


' Change File Name [CTRL-C]
IF a$ = CHR$(3) THEN
     ChangeFileName FileName$
     GOSUB InitializeStatusBar
     GOSUB DisplayFunction
     GOTO KeyProcess
END IF


' Change Keyboard Repeat rate. [CTRL-F1]
IF a$ = CHR$(0) + CHR$(94) THEN
     SetKeySpeed
     GOSUB InitializeStatusBar
     GOSUB DisplayFunction
     GOTO KeyProcess
END IF



' Help Screen [ALT-H]
IF a$ = CHR$(0) + CHR$(35) THEN Help: GOTO KeyProcess



' SHELL to DOS [ALT-D]
IF a$ = CHR$(0) + CHR$(32) THEN
      ScrSave SavedScreen(), 0, 1
      COLOR 7, 0: CLS
      COLOR 15, 4: PRINT "Type EXIT to return to VDRAW."
      COLOR 7, 0
      SHELL
      ScrRest SavedScreen(), 0, 1
      GOTO KeyProcess
END IF


' Display INFO Screen [ALT-I]
IF a$ = CHR$(0) + CHR$(23) THEN Info ESC: GOTO KeyProcess


' If Insert Mode is ON!
IF INS THEN GOSUB InsertCharacters: GOTO KeyProcess


'-----------------------------------------------------
' Place Character and its color attribute onto screen.
POKE PCol, ASC(a$)
POKE PCol + 1, Attr

NotSave = 1
'-----------------------------------------------------

' If the Poke Column is at the last location on screen then stop!
IF PCol = 3838 THEN LOCATE 24, 80: GOTO KeyProcess


col = col + 1: PCol = PCol + 2
GOSUB CheckRowCol

GOTO KeyProcess

'*****************************************************************************



'****************************************************************************
'***********                 GOSUB ROUTINES                  ****************
'****************************************************************************

'-----------------------------------------------------------------------
'-   Make sure cursor stays within a 24x80 screen.                     -
'-----------------------------------------------------------------------
CheckRowCol:
IF col > 80 THEN col = 1: row = row + 1
IF row > 24 THEN row = 24
RETURN
'-----------------------------------------------------------------------




'------------------------------------------------------------------------
'-    Title Screen                                                      -
'------------------------------------------------------------------------
TitleScreen:
LOCATE 25, 1, 0
PRINT "                              -   V D R A W   -                            1.1a";
StringScroll "Brought to you by:", 0, 8, 10, 3, 0, 10, -1, 2, 0, ExitKey$
IF ExitKey$ > "" GOTO ContTitle
StringScroll "S Y N T E C.  ", 1, 10, 10, 3, 0, 10, -1, 10, 0, ExitKey$
IF ExitKey$ > "" GOTO ContTitle
StringScroll "Created by:  Fred R Fuchs.", 1, 15, 300, 2, 0, 1, 0, 14, 0, ExitKey$
IF ExitKey$ > "" GOTO ContTitle
StringScroll "Making Software to make your life a little easier.", 0, 15, 300, 2, 0, 1, 0, 11, 0, ExitKey$
IF ExitKey$ > "" GOTO ContTitle
StringScroll "Keep your eyes open for other SYNTEC products coming to a BBS near you.", 0, 15, 300, 2, 0, 1, 0, 11, 0, ExitKey$
IF ExitKey$ > "" GOTO ContTitle
StringScroll "Press any key to start creating.", 0, 15, 300, 2, 1, 0, 0, 7, 0, ExitKey$

ContTitle:
LOCATE 12, 40, 1
                                                           
COLOR 7, 0
CLS
GOSUB InitializeStatusBar
COLOR 7, 1
RETURN
'--------------------------------------------------------------------------



'--------------------------------------------------------------------------
'-     Display and update the Status Bar.                                 -
'--------------------------------------------------------------------------
Status:
COLOR 7, 1
LOCATE 25, 1, 0: PRINT "         ";
LOCATE 25, 1: PRINT STR$(row) + "," + STR$(col);
'LOCATE 25, 17: PRINT "      ";
'LOCATE 25, 12: PRINT "PCol:" + STR$(PCol);
LOCATE 25, 12: PRINT "      ";
LOCATE 25, 12: PRINT Format$;
LOCATE 25, 20: PRINT "   ";
LOCATE 25, 20: IF INS = 1 THEN COLOR 31, 1: PRINT "Ins";  ELSE COLOR 7, 1: PRINT "Typ";
COLOR 7, 1
LOCATE 25, 24: PRINT "   ";
LOCATE 25, 24: PRINT Attr;
LOCATE 25, 33: PRINT " ";
LOCATE 25, 34: PRINT LTRIM$(STR$(Pg));
LOCATE row, col, 1
RETURN
'-------------------------------------------------------------------------



'-------------------------------------------------------------------------
'-      Set up the Status Bar.                                           -
'-------------------------------------------------------------------------
InitializeStatusBar:
COLOR 7, 1
LOCATE 25, 1
PRINT "                         Pg:                                              ";
LOCATE 25, 36: PRINT FileName$;
RETURN
'-------------------------------------------------------------------------



'-------------------------------------------------------------------------
'-      Clear the screen!                                                -
'-------------------------------------------------------------------------
ClearScreen:
COLOR 14, 4
LOCATE , , 0
LOCATE 25, 1
PRINT "                        Clear Screen....Are You Sure? [y/N]                     ";
SOUND 1500, 2

KeyHit a$
IF UCASE$(a$) = "Y" THEN
   COLOR 7, 0
   CLS
   row = 12: col = 40: PCol = 1838
   RETURN
END IF
a$ = ""
LOCATE row, col

RETURN
'------------------------------------------------------------------------



'-------------------------------------------------------------------
'- END Key - routine to move cursor to end of line on current Row. -
'-------------------------------------------------------------------
GoToEndOfLine:
b$ = ""
FOR i = PCol - ((col * 2) - 2) TO PCol + ((80 - col) * 2) STEP 2
    Char = PEEK(i)
    b$ = b$ + CHR$(Char)
NEXT i
col = 1
b$ = RTRIM$(b$)
col = col + LEN(b$)
IF col > 80 THEN col = 80
IF b$ = "" THEN col = 80
PCol = (row - 1) * 160 + (col - 1) * 2
LOCATE row, col
RETURN
'-------------------------------------------------------------------



'-------------------------------------------------------------------
' -     Insert Characters                                          -
'-------------------------------------------------------------------
InsertCharacters:
    b$ = "": c = 0
    FOR i = PCol TO PCol + ((80 - col) * 2) STEP 2
        c = c + 1
        b$ = b$ + CHR$(PEEK(i))
        InsChar(c) = PEEK(i)
        InsAttr(c) = PEEK(i + 1)
    NEXT i
    
    b$ = RTRIM$(b$)
    IF LEN(a$ + b$) + col > 81 THEN SOUND 1500, 2: RETURN
   
    POKE PCol, ASC(a$): POKE PCol + 1, Attr
   
    col = col + 1: PCol = PCol + 2
    c = 0
    FOR i = 1 TO LEN(b$)
        POKE PCol + c, InsChar(i)
        POKE PCol + (c + 1), InsAttr(i)
        c = c + 2
    NEXT i
    IF col > 80 THEN col = 80: PCol = PCol - 2: SOUND 1500, 2: RETURN
    LOCATE row, col
    RETURN
'-------------------------------------------------------------------



'--------------------------------------------------------------------
'-                  FUNCTION KEY Character Select                   -
'--------------------------------------------------------------------
Functions:

' Function Codes [SHIFT-F1 to SHIFT-F10]
IF a$ = CHR$(0) + CHR$(84) THEN GOSUB F1
IF a$ = CHR$(0) + CHR$(85) THEN GOSUB F2
IF a$ = CHR$(0) + CHR$(86) THEN GOSUB F3
IF a$ = CHR$(0) + CHR$(87) THEN GOSUB F4
IF a$ = CHR$(0) + CHR$(88) THEN GOSUB F5
IF a$ = CHR$(0) + CHR$(89) THEN GOSUB F6
IF a$ = CHR$(0) + CHR$(90) THEN GOSUB F7
IF a$ = CHR$(0) + CHR$(91) THEN GOSUB F8
IF a$ = CHR$(0) + CHR$(92) THEN GOSUB F9
IF a$ = CHR$(0) + CHR$(93) THEN GOSUB F10
GOSUB SetKeys

RETURN

'                   ---------------------------------

F1:
       a$ = "                    "
       a = 218: b = 191: c = 192: d = 217: e = 196
       f = 179: g = 195: h = 180: i = 193: j = 194
       Func = 1
       RETURN

F2:
       a$ = "                    "
       a = 214: b = 183: c = 211: d = 189: e = 196
       f = 186: g = 199: h = 182: i = 208: j = 210
       GOSUB SetKeys
       Func = 2
       RETURN

F3:
       a$ = "                    "
       a = 201: b = 187: c = 200: d = 188: e = 205
       f = 186: g = 204: h = 185: i = 202: j = 203
       Func = 3
       RETURN

F4:
       a$ = "                    "
       a = 213: b = 184: c = 212: d = 190: e = 205
       f = 179: g = 198: h = 181: i = 207: j = 209
       Func = 4
       RETURN

F5:
       a$ = "                    "
       a = 215: b = 206: c = 197: d = 216: e = 172
       f = 171: g = 175: h = 174: i = 241: j = 246
       Func = 5
       RETURN

F6:
       a$ = "                    "
       a = 176: b = 177: c = 178: d = 219: e = 220
       f = 223: g = 221: h = 222: i = 249: j = 250
       Func = 6
       RETURN

F7:
       a$ = "                   "
       a = 128: b = 129: c = 130: d = 131: e = 132
       f = 133: g = 134: h = 135: i = 136: j = 137
       Func = 7
       RETURN

F8:
       a$ = "                   "
       a = 138: b = 139: c = 140: d = 141: e = 142
       f = 143: g = 144: h = 145: i = 146: j = 147
       Func = 8
       RETURN

F9:
       a$ = "                   "
       a = 148: b = 149: c = 150: d = 151: e = 152
       f = 153: g = 154: h = 155: i = 156: j = 157
       Func = 9
       RETURN

F10:
       a$ = "                   "
       a = 158: b = 159: c = 160: d = 161: e = 162
       f = 163: g = 164: h = 165: i = 166: j = 167
       GOSUB SetKeys
       Func = 10
       RETURN

'                       --------------------------------


SetKeys:
      
COLOR 14, 1
LOCATE 25, 51
PRINT a$;
COLOR 7, 1

LOCATE 25, 50: PRINT "1";
LOCATE 25, 53: PRINT "2";
LOCATE 25, 56: PRINT "3";
LOCATE 25, 59: PRINT "4";
LOCATE 25, 62: PRINT "5";
LOCATE 25, 65: PRINT "6";
LOCATE 25, 68: PRINT "7";
LOCATE 25, 71: PRINT "8";
LOCATE 25, 74: PRINT "9";
LOCATE 25, 77: PRINT "10";


       KEY 1, CHR$(a): KEY 2, CHR$(b): KEY 3, CHR$(c): KEY 4, CHR$(d)
       KEY 5, CHR$(e): KEY 6, CHR$(f): KEY 7, CHR$(g): KEY 8, CHR$(h)
       KEY 9, CHR$(i): KEY 10, CHR$(j)
       RETURN





' Display Current Selected Graphic Set.
DisplayFunction:
ON Func GOSUB F1, F2, F3, F4, F5, F6, F7, F8, F9, F10
GOSUB SetKeys
RETURN

'-----------------------------------------------------------------------


'-----------------------------------------------------------------------
' Modify a Toggle screen File Name and place the original name into
' an Array [ File2$() ].

'ModifyFileName:
'
'File2$(ScreenPage) = FileName$
'IF LEFT$(RIGHT$(FileName$, 4), 1) = "." THEN
'       F$ = LEFT$(FileName$, LEN(FileName$) - 4) + ".SCR"
'ELSE
'       F$ = FileName$ + ".SCR"
'END IF
'RETURN
'---------------------------------------------------------------------


'---------------------------------------------------------------------
' Load File Error
FileErr:
     FileError = 1
     RESUME NEXT
'---------------------------------------------------------------------



'*************** Heart Codes ****************
DATA 7,"0", 11,"1", 14,"2", 5,"3", 31,"4", 10,"5", 12,"6", 9,"7", 6,"8"
DATA 3,"9", 2,"A", 13,"B", 79,"C", 78,"D", 75,"E", 71,"F", 33,"G", 100,"H"
DATA 97,"I", 30,"J", 19,"K", 23,"L", 87,"M", 48,"N", 112,"O", 116,"P"
DATA 113,"Q", 127,"R", 124,"S", 121,"T", 15,"U", 64,"V", 16,"W"
DATA 80,"X", 47,"Y", 63,"Z"



'****************  A N S I  *****************
' Black to White on Black background.
DATA 0,[40;30m, 1,[40;34m, 2,[40;32m, 3,[40;36m, 4,[40;31m, 5,[40;35m
DATA 6,[40;33m, 7,[40;37m, 8,[40;1;30m, 9,[40;1;34m, 10,[40;1;32m
DATA 11,[40;1;36m, 12,[40;1;31m, 13,[40;1;35m, 14,[40;1;33m, 15,[40;1;37m

' Black to White on Blue Background.
DATA 16,[44;30m, 17,[44;34m, 18,[44;32m, 19,[44;36m, 20,[44;31m, 21,[44;35m, 22,[44;33m
DATA 23,[44;37m, 24,[44;1;30m, 25,[44;1;34m, 26,[44;1;32m, 27,[44;1;36m, 28,[44;1;31m
DATA 29,[44;1;35m, 30,[44;1;33m, 31,[44;1;37m

' Black to White on Green BackGround.
DATA 32,[42;30m, 33,[42;34m, 34,[42;32m, 35,[42;36m, 36,[42;31m, 37,[42;35m, 38,[42;33m
DATA 39,[42;37m, 40,[42;1;30m, 41,[42;1;34m, 42,[42;1;32m, 43,[42;1;36m, 44,[42;1;31m
DATA 45,[42;1;35m, 46,[42;1;33m, 47,[42;1;37m

' Black to White on Cyan BackGround.
DATA 48,[46;30m, 49,[46;34m, 50,[46;32m, 51,[46;36m, 52,[46;31m, 53,[46;35m, 54,[46;33m
DATA 55,[46;37m, 56,[46;1;30m, 57,[46;1;34m, 58,[46;1;32m, 59,[46;1;36m, 60,[46;1;31m
DATA 61,[46;1;35m, 62,[46;1;33m, 63,[46;1;37m

' Black to White on Red BackGround.
DATA 64,[41;30m, 65,[41;34m, 66,[41;32m, 67,[41;36m, 68,[41;31m, 69,[41;35m, 70,[41;33m
DATA 71,[41;37m, 72,[41;1;30m, 73,[41;1;34m, 74,[41;1;32m, 75,[41;1;36m, 76,[41;1;31m
DATA 77,[41;1;35m, 78,[41;1;33m, 79,[41;1;37m

' Black to White on Magenta BackGround.
DATA 80,[45;30m, 81,[45;34m, 82,[45;32m, 83,[45;36m, 84,[45;31m, 85,[45;35m, 86,[45;33m
DATA 87,[45;37m, 88,[45;1;30m, 89,[45;1;34m, 90,[45;1;32m, 91,[45;1;36m, 92,[45;1;31m
DATA 93,[45;1;35m, 94,[45;1;33m, 95,[45;1;37m

' Black to White on Brown BackGround.
DATA 96,[43;30m, 97,[43;34m, 98,[43;32m, 99,[43;36m, 100,[43;31m, 101,[43;35m, 102,[43;33m
DATA 103,[43;37m, 104,[43;1;30m, 105,[43;1;34m, 106,[43;1;32m, 107,[43;1;36m, 108,[43;1;31m
DATA 109,[43;1;35m, 110,[43;1;33m, 111,[43;1;37m

' Black to White on Light Grey BackGround.
DATA 112,[47;30m, 113,[47;34m, 114,[47;32m, 115,[47;36m, 116,[47;31m, 117,[47;35m, 118,[47;33m
DATA 119,[47;37m, 120,[47;1;30m, 121,[47;1;34m, 122,[47;1;32m, 123,[47;1;36m, 124,[47;1;31m
DATA 125,[47;1;35m, 126,[47;1;33m, 127,[47;1;37m


' Blink - Black to White on Black Background.
DATA 128,[5;30m, 129,[5;34m, 130,[5;32m, 131,[5;36m, 132,[5;31m, 133,[5;35m, 134,[5;33m, 135,[5;37m
DATA 136,[5;1;30m, 137,[5;1;34m, 138,[5;1;32m, 139,[5;1;36m, 140,[5;1;31m, 141,[5;1;35m
DATA 142,[5;1;33m, 143,[5;1;37m

' Blink - Black to White on Blue Background.
DATA 144,[5;44;30m, 145,[5;44;34m, 146,[5;44;32m, 147,[5;44;36m, 148,[5;44;31m, 149,[5;44;35m, 150,[5;44;33m
DATA 151,[5;44;37m, 152,[5;44;1;30m, 153,[5;44;1;34m, 154,[5;44;1;32m, 155,[5;44;1;36m, 156,[5;44;1;31m
DATA 157,[5;44;1;35m, 158,[5;44;1;33m, 159,[5;44;1;37m

' Blink - Black to White on Green BackGround.
DATA 160,[5;42;30m, 161,[5;42;34m, 162,[5;42;32m, 163,[5;42;36m, 164,[5;42;31m, 165,[5;42;35m, 166,[5;42;33m
DATA 167,[5;42;37m, 168,[5;42;1;30m, 169,[5;42;1;34m, 170,[5;42;1;32m, 171,[5;42;1;36m, 172,[5;42;1;31m
DATA 173,[5;42;1;35m, 174,[5;42;1;33m, 175,[5;42;1;37m

' Blink - Black to White on Cyan BackGround.
DATA 176,[5;46;30m, 177,[5;46;34m, 178,[5;46;32m, 179,[5;46;36m, 180,[5;46;31m, 181,[5;46;35m, 182,[5;46;33m
DATA 183,[5;46;37m, 184,[5;46;1;30m, 185,[5;46;1;34m, 186,[5;46;1;32m, 187,[5;46;1;36m, 188,[5;46;1;31m
DATA 189,[5;46;1;35m, 190,[5;46;1;33m, 191,[5;46;1;37m

' Blink - Black to White on Red BackGround.
DATA 192,[5;41;30m, 193,[5;41;34m, 194,[5;41;32m, 195,[5;41;36m, 196,[5;41;31m, 197,[5;41;35m, 198,[5;41;33m
DATA 199,[5;41;37m, 200,[5;41;1;30m, 201,[5;41;1;34m, 202,[5;41;1;32m, 203,[5;41;1;36m, 204,[5;41;1;31m
DATA 205,[5;41;1;35m, 206,[5;41;1;33m, 207,[5;41;1;37m

' Blink - Black to White on Magenta BackGround.
DATA 208,[5;45;30m, 209,[5;45;34m, 210,[5;45;32m, 211,[5;45;36m, 212,[5;45;31m, 213,[5;45;35m, 214,[5;45;33m
DATA 215,[5;45;37m, 216,[5;45;1;30m, 217,[5;45;1;34m, 218,[5;45;1;32m, 219,[5;45;1;36m, 220,[5;45;1;31m
DATA 221,[5;45;1;35m, 222,[5;45;1;33m, 223,[5;45;1;37m

' Blink - Black to White on Brown BackGround.
DATA 224,[5;43;30m, 225,[5;43;34m, 226,[5;43;32m, 227,[5;43;36m, 228,[5;43;31m, 229,[5;43;35m, 230,[5;43;33m
DATA 231,[5;43;37m, 232,[5;43;1;30m, 233,[5;43;1;34m, 234,[5;43;1;32m, 235,[5;43;1;36m, 236,[5;43;1;31m
DATA 237,[5;43;1;35m, 238,[5;43;1;33m, 239,[5;43;1;37m

' Blink - Black to White on Light Grey BackGround.
DATA 240,[5;47;30m, 241,[5;47;34m, 242,[5;47;32m, 243,[5;47;36m, 244,[5;47;31m, 245,[5;47;35m, 246,[5;47;33m
DATA 247,[5;47;37m, 248,[5;47;1;30m, 249,[5;47;1;34m, 250,[5;47;1;32m, 251,[5;47;1;36m, 252,[5;47;1;31m
DATA 253,[5;47;1;35m, 254,[5;47;1;33m, 255,[5;47;1;37m

SUB ChangeFileName (FileName$)

VIEW PRINT 25 TO 25

200 COLOR 0, 7: CLS 2

PRINT " Enter New File Name: ";
COLOR 4, 7: SOUND 1500, .5
INPUT "", NewName$
NewName$ = UCASE$(NewName$)
IF NewName$ = "" GOTO EndSUB9
IF LEN(NewName$) > 12 GOTO 200
IF LEN(NewName$) > 8 AND LEFT$(RIGHT$(NewName$, 4), 1) <> "." GOTO 200
IF LEN(NewName$) < 9 AND LEFT$(RIGHT$(NewName$, 4), 1) <> "." THEN
    IF Format$ = "Ascii" THEN NewName$ = NewName$ + ".ASC"
    IF Format$ = "Ansi" THEN NewName$ = NewName$ + ".ANS"
    IF Format$ = "Heart" THEN NewName$ = NewName$ + ".MNU"
END IF

Exist NewName$, Found
IF Found THEN
    CLS : COLOR 4, 7
    PRINT "  "; UCASE$(NewName$); : COLOR 0, 7
    PRINT " allready exists - Overwrite it? [y/N]";
    KeyHit a$
    IF UCASE$(a$) <> "Y" GOTO 200
END IF
COLOR 0, 7


EndSUB9:
      VIEW PRINT 1 TO 25
      IF NewName$ > "" THEN FileName$ = NewName$
      NotSave = 1
      END SUB

SUB EndProgram

VIEW PRINT 25 TO 25
COLOR 14, 4: CLS 2
PRINT "                     Are you sure you want to Quit? [y/N]                       ";
SOUND 700, 3
KeyHit a$
a$ = UCASE$(a$)
IF a$ <> "Y" GOTO EndSUB50


IF NotSave = 1 THEN FileNotSaved



LOCATE , , 1, 7, 7

       KEY 1, CHR$(0) + CHR$(59): KEY 2, CHR$(0) + CHR$(60)
       KEY 3, CHR$(0) + CHR$(61): KEY 4, CHR$(0) + CHR$(62)
       KEY 5, CHR$(0) + CHR$(63): KEY 6, CHR$(0) + CHR$(64)
       KEY 7, CHR$(0) + CHR$(65): KEY 8, CHR$(0) + CHR$(66)
       KEY 9, CHR$(0) + CHR$(67): KEY 10, CHR$(0) + CHR$(68)


VIEW PRINT 1 TO 25
COLOR 7, 0: CLS
ESC = 1
Info ESC
PRINT : PRINT
SpeedKey 1, 11
SYSTEM


EndSUB50:
     VIEW PRINT 1 TO 25
     COLOR 7, 1
     END SUB

SUB FileNotSaved
   
    COLOR 15, 4: CLS 2
    PRINT "                  Current File Not Saved. Save it Now? [Y/n]";
    SOUND 1500, 3
    KeyHit a$
    IF UCASE$(a$) <> "N" THEN
          SaveFile
          VIEW PRINT 25 TO 25
          COLOR 0, 7
    END IF
    CLS 2


END SUB

SUB FillScreen

Go3:
    VIEW PRINT 25 TO 25
    COLOR 0, 7: CLS 2
    PRINT " Fill screen with "; : COLOR 4, 7: PRINT "C"; : COLOR 0, 7
    PRINT "olor or with a C"; : COLOR 4, 7: PRINT "h";
    COLOR 0, 7: PRINT "aracter [C/H]: ";
    SOUND 1500, 2

    KeyHit a$
   
    a$ = UCASE$(a$)
    IF a$ = CHR$(27) OR a$ = "" GOTO EndSUB44
    IF a$ = "C" THEN
        UnCalcAttr Fore, Back, Attr
        IF NotSave = 1 THEN
             SOUND 1200, 2
             COLOR 0, 7: CLS 2
             PRINT " Overwrite Current Screen? [y/N]: ";
             KeyHit a$: a$ = UCASE$(a$)
             IF a$ <> "Y" GOTO EndSUB44
        END IF
        VIEW PRINT 1 TO 24
        COLOR Fore, Back
        CLS 2
        NotSave = 1
        GOTO EndSUB44
    END IF

    IF a$ = "H" THEN
        CLS 2
        PRINT " Please enter the ASCII number of character to fill screen with: ";
        COLOR 4, 7
        SOUND 1500, 2
        LINE INPUT "", Fill$
        IF Fill$ = "" OR LEN(Fill$) > 3 GOTO Go3
        Fill = VAL(Fill$)
       
        IF NotSave = 1 THEN
             SOUND 1200, 2
             COLOR 0, 7: CLS 2
             PRINT " Overwrite Current Screen? [y/N]: ";
             KeyHit a$: a$ = UCASE$(a$)
             IF a$ <> "Y" GOTO EndSUB44
        END IF

        a = 0
        DO
          POKE a, Fill
          a = a + 1
          POKE a, Attr
          a = a + 1
        LOOP UNTIL a = 3840
        NotSave = 1
        GOTO EndSUB44
    END IF

    GOTO Go3

EndSUB44:
      VIEW PRINT 1 TO 25
      END SUB

SUB Help

ScrSave SavedScreen(), 0, 1
    
COLOR 0, 2: CLS : LOCATE , , 0
PRINT "Ŀ"
PRINT "                                 V D R A W                                    "
PRINT "     From:                          1.1a                          Syntec      "
PRINT ""
COLOR 0, 2: PRINT
PRINT "      ALT-A....Change Color            CTRL-Pg Up ....Scroll screen up"
PRINT "      ALT-C....Clear Screen            CTRL-Pg Dwn....Scroll screen down"
PRINT "      ALT-D....Shell to DOS            CTRL-Lt Arrow..Scroll screen left"
PRINT "      ALT-F....Fill Screen             CTRL-Rt Arrow..Scroll screen right"
PRINT "      ALT-H....This Help               CTRL-F1........Set Cursor speed"
PRINT "      ALT-I....VDRAW Info              CTRL-Home......Put cursor on 1, 1"
PRINT "      ALT-L....Load File               CTRL-C.........Chg current file name"
PRINT "      ALT-N....Toggle Screens          Pg Up/Dn.......Up/Dn-list Attributes"
PRINT "      ALT-R....Re-Color Text           Tab............Tab cursor right"
PRINT "      ALT-S....Save File               BackSpace......Delete Char behind Crs"
PRINT "      ALT-T....Set Tab Space           Insert.........Insert Mode (Toggle)"
PRINT "      ALT Y....Change Format           Del............Del Char under Cursor"
PRINT "      ALT -....Delete Row              Home...........Put cursor in col 1"
PRINT "      ALT +....Insert Row              End............Put cursor end of line"
PRINT
PRINT "      SHIFT-F1 to F10 .. Select graphic templates"
PRINT "      F1 to F10 ........ Place graphic char on screen"
PRINT "      ESC .............. Quit VDRAW"
LOCATE 25, 1
PRINT "                         Press any Key to Exit Help";


KeyHit a$
    
    
ScrRest SavedScreen(), 0, 1
LOCATE , , 1
END SUB

SUB Info (ESC)

ScrSave SavedScreen(), 0, 1
   
COLOR 7, 0: CLS : LOCATE , , 0: COLOR 15, 4
PRINT "Ŀ"
PRINT "                                V D R A W   (c)                             "
PRINT "                                                                            "
PRINT "                                  V 1.1a                                    "
PRINT "                                                                            "
PRINT "                               Public Domain                                "
PRINT "                       ------------------------------                       "
PRINT "                           By:  Fred R Fuchs                                "
PRINT "                                                                            "
PRINT "                              2264 Rainier St                               "
PRINT "                             Clearbrook,  B.C.                              "
PRINT "                             CANADA    V2T 3E6                              "
PRINT "                       ------------------------------                       "
PRINT "      If you would like to see more enhancements to VDRAW then please       "
PRINT "      give a little to the cause.                                           "
PRINT "                                                     "
PRINT "      Look for other fine products from    ķ    ķ  ҷ        "
PRINT "                                           Ľ Ķ      ӽ        "
PRINT "                                           Ľ                  (tm)  "
PRINT ""


IF ESC = 1 THEN GOTO EndSUB224

KeyHit a$

ScrRest SavedScreen(), 0, 1
LOCATE , , 1

EndSUB224:
END SUB

SUB KeyHit (a$)

DO
  a$ = INKEY$
LOOP UNTIL a$ > ""

END SUB

SUB LoadFile

ON ERROR GOTO FileErr

File$ = FileName$
ScrSave SavedScreen(), 0, 1


Main1:
b$ = FileSpec$
IF b$ = "" THEN b$ = "*.*"
Pg = 1


Main2:
COLOR 7, 1: CLS : a = 0: j = 0

GOSUB FindPath

COLOR 0, 7: LOCATE 25, 1
PRINT SPACE$(80);
COLOR 7, 1
LOCATE 2, 1

REDIM DirFile$(1 TO 1500), Hide(1 TO 1500)
REDIM ListPage(1 TO 20), SavedScreen2(1 TO 2000)


ListPage(1) = 115

FindFirstF b$, 0 + 2 + 4 + 16, ErrCode
    DO UNTIL ErrCode
       File$ = SPACE$(12)
       a = a + 1
       GetNameF File$, NameLen
       GetAttrF FA
      
       IF FA AND 1 THEN Hide(a) = 1     'Read Only
       IF FA AND 2 THEN Hide(a) = 2     'Hidden
      
       IF FA AND 4 THEN Hide(a) = 4     'System
       IF FA AND 16 THEN Hide(a) = 16   'Directory
       IF FA = 18 THEN Hide(a) = 18     'Hidden Directory

       DirFile$(a) = File$
       IF DirFile$(a) = "" THEN a = a - 1
       FindNextF ErrCode
    LOOP

GOSUB TopStatus
   
      j = 1
     
      DO
         j = j + 1
         ListPage(j) = ListPage(j - 1) + 115
      LOOP UNTIL ListPage(j) >= a



    ' Modify the top j count to add more pages of files.
    j = 0

    DO UNTIL j = a
        j = j + 1
        IF j = ListPage(Pg) THEN
           MaxRow = CSRLIN
           COLOR 7, 1
           IF Hide(j) = 1 THEN COLOR 11, 1      'Read Only
           IF Hide(j) = 2 THEN COLOR 14, 1      'Hidden
           IF Hide(j) = 4 THEN COLOR 15, 1      'System
           IF Hide(j) = 16 OR Hide(j) = 18 THEN COLOR 3, 1    'Directory
           PRINT DirFile$(j);
           GOTO GetFile
        END IF
    
        COLOR 7, 1
        IF Hide(j) = 1 THEN COLOR 11, 1         'Read Only
        IF Hide(j) = 2 THEN COLOR 14, 1         'Hidden
        IF Hide(j) = 4 THEN COLOR 15, 1         'System
        IF Hide(j) = 16 OR Hide(j) = 18 THEN COLOR 3, 1       'Directory
        PRINT DirFile$(j),
6    LOOP
   
    MaxRow = CSRLIN


'-----------------------------------------------------------------------
GetFile:

IF Pg = 1 THEN k = 1
row2 = 2: col2 = 1: b$ = ""

GOSUB StatusBar

LOCATE 2, 1: COLOR 4, 7
LOCATE row2, col2: PRINT DirFile$(k)
LOCATE row2, col2



Start:

IF Hide(k) = 0 THEN LOCATE 25, 14: PRINT "             ";
IF b$ = "" THEN LOCATE 25, LEN(RTRIM$(DirFile$(k))) + 2 ELSE LOCATE 25, LEN(b$) + 2
    
     

KeyHit a$

     File$ = RTRIM$(DirFile$(k))

' Cursor Left
IF a$ = CHR$(0) + CHR$(75) THEN
    IF row2 <= 2 AND col2 <= 1 THEN row2 = 2: col2 = 1: GOTO Start
    k = k - 1: b$ = ""
    IF k < 1 THEN k = 1: GOTO Start
    col2 = col2 - 14
    'IF row2 <= 2 AND col2 <= 1 THEN row2 = 2: col2 = 1
    IF col2 < 1 THEN
          row2 = row2 - 1: col2 = 57
          LOCATE row2 + 1, 1
          COLOR 7, 1
          IF Hide(k + 1) = 1 THEN COLOR 11, 1      'Read Only
          IF Hide(k + 1) = 2 THEN COLOR 14, 1      'Hidden
          IF Hide(k + 1) = 4 THEN COLOR 15, 1      'System
          IF Hide(k + 1) = 16 OR Hide(k + 1) = 18 THEN COLOR 3, 1  'Directory
          PRINT DirFile$(k + 1);
    END IF
    IF row2 < 2 THEN row2 = 2
    IF col2 < 57 THEN
          LOCATE row2, col2 + 14
          COLOR 7, 1
          IF Hide(k + 1) = 1 THEN COLOR 11, 1    'Read only
          IF Hide(k + 1) = 2 THEN COLOR 14, 1    'Hidden
          IF Hide(k + 1) = 4 THEN COLOR 15, 1    'System
          IF Hide(k + 1) = 16 OR Hide(k + 1) = 18 THEN COLOR 3, 1'Directory
          PRINT DirFile$(k + 1);
    END IF
    LOCATE row2, col2
    IF Hide(k) = 18 THEN COLOR 20, 7 ELSE COLOR 4, 7
    PRINT DirFile$(k);
    LOCATE 25, 2: COLOR 4, 7: PRINT DirFile$(k);
    IF Hide(k) = 1 THEN PRINT "  [Read Only]"; : SOUND 5000, .5
    IF Hide(k) = 2 THEN PRINT "  [Hidden]   "; : SOUND 5000, .5
    IF Hide(k) = 4 THEN PRINT "  [System]   "; : SOUND 5000, .5
    IF Hide(k) = 16 THEN PRINT "      <DIR>  ";
    IF Hide(k) = 18 THEN PRINT "  <Hid DIR>  "; : SOUND 5000, .5
    GOTO Start
END IF

' Cursor Right
IF a$ = CHR$(0) + CHR$(77) THEN
    IF row2 >= 24 AND col2 >= 57 THEN row2 = 24: col2 = 57: GOTO Start
    k = k + 1: b$ = ""
    IF k > a THEN k = a: GOTO Start
    col2 = col2 + 14
    'IF row2 >= 24 AND col2 >= 80 THEN row2 = 24: col2 = 80
    IF col2 > 57 THEN
          row2 = row2 + 1: col2 = 1
          LOCATE row2 - 1, 57
          COLOR 7, 1
          IF Hide(k - 1) = 1 THEN COLOR 11, 1    'Read Only
          IF Hide(k - 1) = 2 THEN COLOR 14, 1    'Hidden
          IF Hide(k - 1) = 4 THEN COLOR 15, 1    'System
          IF Hide(k - 1) = 16 OR Hide(k - 1) = 18 THEN COLOR 3, 1'Directory
          PRINT DirFile$(k - 1)
    END IF
    IF row2 > 24 THEN row2 = 24
    IF col2 > 13 THEN
          LOCATE row2, col2 - 14
          COLOR 7, 1
          IF Hide(k - 1) = 1 THEN COLOR 11, 1    'Read Only
          IF Hide(k - 1) = 2 THEN COLOR 14, 1    'Hidden
          IF Hide(k - 1) = 4 THEN COLOR 15, 1    'System
          IF Hide(k - 1) = 16 OR Hide(k - 1) = 18 THEN COLOR 3, 1'Directory
          PRINT DirFile$(k - 1);
    END IF
    LOCATE row2, col2
    IF Hide(k) = 18 THEN COLOR 20, 7 ELSE COLOR 4, 7
    PRINT DirFile$(k);
    LOCATE 25, 2: COLOR 4, 7: PRINT DirFile$(k);
    IF Hide(k) = 1 THEN PRINT "  [Read Only]"; : SOUND 5000, .5
    IF Hide(k) = 2 THEN PRINT "  [Hidden]   "; : SOUND 5000, .5
    IF Hide(k) = 4 THEN PRINT "  [System]   "; : SOUND 5000, .5
    IF Hide(k) = 16 THEN PRINT "      <DIR>  ";
    IF Hide(k) = 18 THEN PRINT "  <Hid DIR>  "; : SOUND 5000, .5
    GOTO Start
END IF


' Cursor Down
IF a$ = CHR$(0) + CHR$(80) THEN
      IF row2 = MaxRow GOTO Start
      IF k + 5 > a GOTO Start
      IF row2 > 23 THEN row2 = 24: GOTO Start
      row2 = row2 + 1: k = k + 5: b$ = ""
      IF k > a THEN k = a
      IF row2 > 2 THEN
            LOCATE row2 - 1, col2
            COLOR 7, 1
            IF Hide(k - 5) = 1 THEN COLOR 11, 1     'Read Only
            IF Hide(k - 5) = 2 THEN COLOR 14, 1     'Hidden
            IF Hide(k - 5) = 4 THEN COLOR 15, 1     'System
            IF Hide(k - 5) = 16 OR Hide(k - 5) = 18 THEN COLOR 3, 1 'Directory
            PRINT DirFile$(k - 5);
      END IF
      LOCATE row2, col2
      IF Hide(k) = 18 THEN COLOR 20, 7 ELSE COLOR 4, 7
      PRINT DirFile$(k);
      LOCATE 25, 2: COLOR 4, 7: PRINT DirFile$(k);
      IF Hide(k) = 1 THEN PRINT "  [Read Only]"; : SOUND 5000, .5
      IF Hide(k) = 2 THEN PRINT "  [Hidden]   "; : SOUND 5000, .5
      IF Hide(k) = 4 THEN PRINT "  [System]   "; : SOUND 5000, .5
      IF Hide(k) = 16 THEN PRINT "      <DIR>  ";
      IF Hide(k) = 18 THEN PRINT "  <Hid DIR>  "; : SOUND 5000, .5
      GOTO Start
END IF


' Cursor Up
IF a$ = CHR$(0) + CHR$(72) THEN
      IF row2 < 3 THEN row2 = 2: GOTO Start
      row2 = row2 - 1: k = k - 5: b$ = ""
      IF k < 1 THEN k = 1
      IF row2 = 23 THEN
            LOCATE row2 + 1, col2
            COLOR 7, 1
            IF Hide(k + 5) = 1 THEN COLOR 11, 1     'Read Only
            IF Hide(k + 5) = 2 THEN COLOR 14, 1     'Hidden
            IF Hide(k + 5) = 4 THEN COLOR 15, 1     'System
            IF Hide(k + 5) = 16 OR Hide(k + 5) = 18 THEN COLOR 3, 1 'Directory
            PRINT DirFile$(k + 5);
            GOTO D24
      END IF
      IF row2 >= 2 THEN
            LOCATE row2 + 1, col2
            COLOR 7, 1
            IF Hide(k + 5) = 1 THEN COLOR 11, 1      'Read Only
            IF Hide(k + 5) = 2 THEN COLOR 14, 1      'Hidden
            IF Hide(k + 5) = 4 THEN COLOR 15, 1      'System
            IF Hide(k + 5) = 16 OR Hide(k + 5) = 18 THEN COLOR 3, 1  'Directory
            PRINT DirFile$(k + 5)
      END IF
D24:  LOCATE row2, col2
      IF Hide(k) = 18 THEN COLOR 20, 7 ELSE COLOR 4, 7
      PRINT DirFile$(k);
      LOCATE 25, 2: COLOR 4, 7: PRINT DirFile$(k);
      IF Hide(k) = 1 THEN PRINT "  [Read Only]"; : SOUND 5000, .5
      IF Hide(k) = 2 THEN PRINT "  [Hidden]   "; : SOUND 5000, .5
      IF Hide(k) = 4 THEN PRINT "  [System]   "; : SOUND 5000, .5
      IF Hide(k) = 16 THEN PRINT "      <DIR>  ";
      IF Hide(k) = 18 THEN PRINT "  <Hid DIR>  "; : SOUND 5000, .5
      GOTO Start
END IF


' Page Down
IF a$ = CHR$(0) + CHR$(81) AND a > 115 THEN
      IF j = a GOTO Start
      VIEW PRINT 2 TO 24
      COLOR 7, 1: CLS 2
      VIEW PRINT 1 TO 25
      k = ListPage(Pg) + 1
      Pg = Pg + 1: IF Pg > 50 THEN Pg = 50
      GOSUB TopStatus
      row2 = 2: col2 = 1: LOCATE row2, col2
      GOTO 6
END IF

' Page Up
IF a$ = CHR$(0) + CHR$(73) THEN
      IF Pg = 1 GOTO Start
      VIEW PRINT 2 TO 24
      COLOR 7, 1: CLS 2
      VIEW PRINT 1 TO 25
      Pg = Pg - 1
      IF Pg <= 1 THEN Pg = 1: k = 1: j = 0 ELSE j = ListPage(Pg) - 115
      k = ListPage(Pg) - 114
      GOSUB TopStatus
      row2 = 2: col2 = 1: LOCATE row2, col2
      GOTO 6
END IF



' Backspace
IF a$ = CHR$(8) THEN
      IF b$ = "" GOTO Start
      b$ = LEFT$(b$, LEN(b$) - 1)
      LOCATE 25, 2: COLOR 4, 7
      PRINT "                                    ";
      LOCATE 25, 2
      PRINT b$;
      GOTO Start
END IF



' ENTER
IF a$ = CHR$(13) THEN
     IF b$ > "" THEN
          GOSUB EnteredName
          IF flag4 = 2 THEN flag4 = 0: GOTO Main2
          IF flag4 = 1 THEN
               flag4 = 0
               COLOR 0, 7
               'LOCATE 25, 1: PRINT SPACE$(80);
               GOSUB StatusBar
               GOTO Start
          END IF
          GOTO 311
     END IF
     d$ = RTRIM$(DirFile$(k))
    
     IF Hide(k) = 16 OR Hide(k) = 18 THEN
         
          IF d$ = "." THEN CHDIR "\": b$ = "*.*": GOTO Go5
          IF d$ = ".." THEN CHDIR d$: b$ = "*.*": GOTO Go5
          IF RIGHT$(Dir$, 1) <> "\" THEN b$ = Dir$ + "\" + d$ + "\*.*"
          IF RIGHT$(Dir$, 1) = "\" THEN b$ = Dir$ + d$ + "\*.*"
         
Go5:      GOSUB EnteredName
          GOTO Main1
     END IF
     FileName$ = d$
     IF FileName$ = "" THEN b$ = "*.*": GOTO Main1
311  GOSUB LoadUpFile
     ERASE DirFile$
     GOTO EndSUB10
END IF



' Hide or Expose a File. [ALT-A]
IF a$ = CHR$(0) + CHR$(30) THEN
      VIEW PRINT 25 TO 25
      COLOR 0, 7: CLS 2
      PRINT " Set File Attribute - "; : COLOR 4, 7: PRINT "E"; : COLOR 0, 7
      PRINT "xpose, "; : COLOR 4, 7: PRINT "H"; : COLOR 0, 7
      PRINT "ide, "; : COLOR 4, 7: PRINT "R"; : COLOR 0, 7: PRINT "ead Only or ";
      COLOR 4, 7: PRINT "S"; : COLOR 0, 7: PRINT "ystem File [E-H-R-S]: ";
      SOUND 1500, 1

      KeyHit a$: a$ = UCASE$(a$)
      IF a$ = "E" THEN SetFAttr File$, 0
      IF a$ = "H" THEN SetFAttr File$, 2
      IF a$ = "R" THEN SetFAttr File$, 1
      IF a$ = "S" THEN SetFAttr File$, 4
      VIEW PRINT 1 TO 25
      IF a$ = "E" OR a$ = "H" OR a$ = "R" OR a$ = "S" GOTO Main1
      GOSUB StatusBar
      GOTO Start
END IF


' Copy File [ALT-C]
IF a$ = CHR$(0) + CHR$(46) THEN
     VIEW PRINT 25 TO 25
     COLOR 0, 7: CLS 2
     IF RIGHT$(Dir$, 1) <> "\" THEN
        SrcFile$ = Dir$ + "\" + File$
     ELSE
        SrcFile$ = Dir$ + File$
     END IF
     PRINT "To Where do you want to copy "; File$; ": "; : COLOR 4, 7
     LINE INPUT "", DestFile$
     IF DestFile$ = "" GOTO Go1
     SHELL "COPY " + SrcFile$ + " " + DestFile$ + " >NUL"
Go1: VIEW PRINT 1 TO 25
     GOTO Main1
END IF


' Delete File [ALT-D]
IF a$ = CHR$(0) + CHR$(32) THEN
     VIEW PRINT 25 TO 25
     COLOR 0, 7: CLS 2
     PRINT " Are you sure you want to Delete "; File$; " [y/N]: ";
     KeyHit a$
     a$ = UCASE$(a$)
     IF a$ <> "Y" GOTO Start
     KILL File$
     VIEW PRINT 1 TO 25
     b$ = Dir$ + "\*.*"
     GOTO Main2
END IF


' Re-Name a File [ALT-R]
IF a$ = CHR$(0) + CHR$(19) THEN
     VIEW PRINT 25 TO 25
     COLOR 0, 7: CLS 2
     SOUND 1500, 1
     PRINT " Enter New file name: ";
     COLOR 4, 7
     LINE INPUT "", NewName$
     IF NewName$ = "" OR LEN(NewName$) > 12 THEN GOTO Go2
     Rename File$, NewName$, ErrCode
     IF ErrCode THEN CLS 2: PRINT " -: ERROR :-  Re-Naming File"; : SLEEP 2
Go2: VIEW PRINT 1 TO 25
     GOTO Main1
END IF



' View File [ALT-V]
IF a$ = CHR$(0) + CHR$(47) THEN
     ScrSave SavedScreen2(), 0, 1
     GOSUB PrintLoading
     f$ = "Ascii"

     VIEW PRINT 1 TO 24
     COLOR 7, 0: CLS 2
     row3 = 1: col3 = 1: b = 0: FileError = 0

     OPEN File$ FOR INPUT AS #1
         DO UNTIL EOF(1)
            IF b = 3840 THEN EXIT DO
            a$ = INPUT$(1, #1)
            IF FileError THEN EXIT DO
            IF b = 0 AND a$ = CHR$(27) THEN f$ = "Ansi"
            IF b = 0 AND a$ = CHR$(3) THEN f$ = "Heart"
            IF a$ = CHR$(13) THEN         'Eliminate the carriage return
               a$ = INPUT$(1, #1)         'and Line Feed.
               row3 = row3 + 1: col3 = 1
               GOTO 210
            END IF
'         *************************************************
            IF a$ = CHR$(3) AND f$ = "Heart" THEN
                   a$ = INPUT$(1, #1)
                   IF FileError THEN EXIT DO
                   FOR i = 1 TO 36
                       IF a$ = ActHeartCode$(i) THEN Attr = HeartCode(i): Match = 1: EXIT FOR
                   NEXT i
            END IF
            IF Match = 1 THEN Match = 0: GOTO 210
'          ************************************************
            IF a$ = CHR$(27) AND f$ = "Ansi" THEN
Go9:              Ans$ = ""
                  DO
                     a$ = INPUT$(1, #1)
                     IF FileError THEN EXIT DO
                     Ans$ = Ans$ + a$
                  LOOP UNTIL a$ = CHR$(27)
                 
                  Ans$ = CHR$(27) + LEFT$(Ans$, LEN(Ans$) - 1)
                 
                  DMPrint Ans$
                 
                  IF a$ = CHR$(27) GOTO Go9
                  GOTO 210
            END IF
'          ************************************************
            IF row3 > 24 THEN EXIT DO

            POKE (row3 - 1) * 160 + (col3 - 1) * 2, ASC(a$)
            POKE ((row3 - 1) * 160 + (col3 - 1) * 2) + 1, Attr
            col3 = col3 + 1
210         LOOP
        CLOSE #1
  
     LOCATE 25, 1: COLOR 0, 7
     PRINT "                                                 Press Any Key To Exit......  ";
     LOCATE 25, 1: PRINT " Format: "; : COLOR 4, 7: PRINT f$;
     COLOR 0, 7: PRINT "      Viewing: "; : COLOR 4, 7: PRINT File$;
     KeyHit a$
     
     LOCATE 25, 1: COLOR 0, 7
     PRINT "                                                                               ";
     LOCATE 25, 2
     PRINT f$ + "         ";
     LOCATE 25, 63: PRINT "   Press Any Key ";
     COLOR 4, 7
     LOCATE 25, INT(40 - (LEN(f$) / 2)): PRINT File$;
     ScrSave ToggleScreen(), 0, 1
    
     ScrRest SavedScreen2(), 0, 1
     IF Attr = 0 THEN Attr = 7
     GOTO Start
END IF



'Exit
IF a$ = CHR$(27) THEN
     ScrRest SavedScreen(), 0, 1
     LOCATE , , 1
     GOTO EndSUB10
END IF



LOCATE 25, 2: COLOR 4, 7
PRINT "                               ";
b$ = b$ + UCASE$(a$)
LOCATE 25, 2
PRINT b$;


GOTO Start

'-----------------------------------------------------------------------
LoadUpFile:

        ScrRest SavedScreen(), 0, 1
        LOCATE , , 1
       
        VIEW PRINT 25 TO 25
        COLOR 4, 7: CLS 2

       
        IF NotSave = 1 THEN
            SWAP File$, FileName$
            FileNotSaved
            SWAP File$, FileName$
        END IF
      
        VIEW PRINT 25 TO 25
        GOSUB PrintLoading
        VIEW PRINT 1 TO 24
        COLOR 7, 0: CLS 2
     
        row = 1: col = 1: Attr = 7: Format$ = "Ascii"
        Match = 0: NotSave = 0: a = 0: FileError = 0

        OPEN FileName$ FOR INPUT AS #1
            DO UNTIL EOF(1)
               IF a = 3840 THEN EXIT DO
               a$ = INPUT$(1, #1)
               IF FileError THEN EXIT DO
               IF a = 0 AND a$ = CHR$(27) THEN Format$ = "Ansi"
               IF a = 0 AND a$ = CHR$(3) THEN Format$ = "Heart"
               IF a$ = CHR$(13) THEN         'Eliminate the carriage return
                  a$ = INPUT$(1, #1)         'and Line Feed.
                  row = row + 1: col = 1
                  GOTO 107
               END IF
              
'***************************  HEART  *********************
               IF Format$ = "Heart" AND a$ = CHR$(3) THEN
                  a$ = INPUT$(1, #1)
                  FOR i = 1 TO 36
                      IF a$ = ActHeartCode$(i) THEN Attr = HeartCode(i): Match = 1: EXIT FOR
                  NEXT i
                  IF Match = 1 THEN Match = 0: GOTO 107
               END IF
            
'****************************  ANSI  **********************
            IF Format$ = "Ansi" AND a$ = CHR$(27) THEN
                  
Go10:             Ans$ = ""
                  DO
                     a$ = INPUT$(1, #1)
                     IF FileError THEN EXIT DO
                     Ans$ = Ans$ + a$
                  LOOP UNTIL a$ = CHR$(27)
                 
                  Ans$ = CHR$(27) + LEFT$(Ans$, LEN(Ans$) - 1)
                  
                  DMPrint Ans$
                  
                  IF a$ = CHR$(27) GOTO Go10
                  GOTO 107
            END IF
'**********************************************************
              
               IF row > 24 THEN EXIT DO
               POKE (row - 1) * 160 + (col - 1) * 2, ASC(a$)
               POKE ((row - 1) * 160 + (col - 1) * 2) + 1, Attr
               col = col + 1
107         LOOP
        CLOSE #1
        
Attr = 7

RETURN

'********************************************************************



'--------------------------------------------------------------------
PrintLoading:           
         LOCATE 25, 1: COLOR 4, 7
         PRINT "                              Loading.....Processing                            ";
         RETURN
'---------------------------------------------------------------------
   

'---------------------------------------------------------------------
EnteredName:
   IF b$ = "" THEN RETURN
   IF INSTR(b$, "*.") > 0 OR INSTR(b$, ".*") > 0 THEN
         flag4 = 2
         FileSpec$ = b$
         Drive$ = SPACE$(1)
         SubDir$ = SPACE$(64)
         File$ = SPACE$(12)
         ParseFSpec FileSpec$, Drive$, DLen, SubDir$, SLen, File$, FLen
         Drive$ = LEFT$(Drive$, DLen)
         SubDir$ = LEFT$(SubDir$, SLen)
         File$ = LEFT$(File$, FLen)
         SetDrv Drive$
         SetSub SubDir$, ErrCode
         RETURN
   END IF
   Exist b$, Found
   IF NOT Found THEN
         flag4 = 1
         COLOR 0, 7
         LOCATE 25, 1: PRINT SPACE$(80);
         LOCATE 25, 2: COLOR 4, 7
         PRINT b$;
         COLOR 0, 7
         PRINT " Does not exist! - Press any key.";
         SOUND 2000, 2
         KeyHit a$
         GOSUB StatusBar
         b$ = ""
         COLOR 7, 1
         RETURN
    END IF
    COLOR 0, 7
    FileName$ = b$
RETURN
'-----------------------------------------------------------------------



'------------------------------------------------------------------------
FindPath:
Drive$ = GetDrive$
SubDir$ = GetSub2$(Drive$)
Dir$ = Drive$ + ":" + SubDir$
RETURN
'-----------------------------------------------------------------------


'-----------------------------------------------------------------------
TopStatus:
LOCATE 1, 1: COLOR 0, 3: PRINT SPACE$(80)
LOCATE 1, 1: PRINT " "; CHR$(27); CHR$(25); CHR$(24); CHR$(26);
LOCATE 1, 72: PRINT "Page:"; Pg
IF a > 115 THEN
   LOCATE 1, 1
   PRINT " "; CHR$(27); CHR$(25); CHR$(24); CHR$(26); " PgDn/PgUp"
END IF
LOCATE 1, INT(40 - ((LEN(Dir$) / 2) - 1))
COLOR 0, 3: PRINT CHR$(34); Dir$; CHR$(34)
COLOR 7, 1
RETURN
'---------------------------------------------------------------------

'---------------------------------------------------------------------
' Display Status Bar
StatusBar:
COLOR 4, 7
LOCATE 25, 1: PRINT SPACE$(80);
LOCATE 25, 2: PRINT DirFile$(k);
IF Hide(k) = 1 THEN PRINT "  [Read Only]";
IF Hide(k) = 2 THEN PRINT "  [Hidden]   ";
IF Hide(k) = 4 THEN PRINT "  [System]   ";
IF Hide(k) = 16 THEN PRINT "      <DIR> ";
IF Hide(k) = 18 THEN PRINT "  <Hid DIR> "; : SOUND 5000, .5
LOCATE 25, 38: COLOR 0, 7: PRINT " "; : COLOR 4, 7
PRINT "ALT"; : COLOR 0, 7: PRINT " +  "; : COLOR 4, 7: PRINT "A"; : COLOR 0, 7: PRINT "ttr";
COLOR 4, 7: PRINT " C"; : COLOR 0, 7: PRINT "opy "; : COLOR 4, 7: PRINT "D";
COLOR 0, 7: PRINT "el "; : COLOR 4, 7: PRINT "R"; : COLOR 0, 7: PRINT "en "; : COLOR 4, 7: PRINT "V";
COLOR 0, 7: PRINT "iew or "; : COLOR 4, 7: PRINT "ESCAPE"; : COLOR 0, 7
RETURN
'----------------------------------------------------------------------


EndSUB10:
        VIEW PRINT 1 TO 25
        ERASE ListPage, SavedScreen2, Hide, DirFile$
        File$ = FileName$
        ON ERROR GOTO 0
        FileError = 0
        END SUB

SUB PageHeartAttrDWN (HeartCode(), Attr%)

aA = aA + 1
IF aA > 36 THEN aA = 36
Attr% = HeartCode(aA)

END SUB

SUB ReColorText (row, col, PCol)

VIEW PRINT 25 TO 25
COLOR 7, 1: CLS 2
PRINT " Re-Color all text on "; : COLOR 15, 1: PRINT "S";
COLOR 7, 1: PRINT "creen or Re-Color a specific ";
COLOR 15, 1: PRINT "A"; : COLOR 7, 1: PRINT "rea [S/A]: ";
 
  DO UNTIL a$ = "A" OR a$ = "S"
    KeyHit a$
    a$ = UCASE$(a$)
   
    IF a$ = "S" THEN
        CLS 2
        OCCA = PEEK(PCol + 1)
        LINE INPUT " Enter new Character Color Attribute (CCA)  [0 to 255]: ", b$
        IF b$ = "" THEN EXIT DO
        CCA = VAL(b$)
        IF CCA > 255 THEN EXIT DO
        DReColor &HB800, PCol, OCCA, CCA
        NotSave = 1
    END IF
   
    IF a$ = "A" THEN
        CLS 2
        LINE INPUT " Cursor is on Top row & Left column - Enter Bottom Row: ", BottomRow$
        IF BottomRow$ = "" THEN BottomRow$ = STR$(row)
        BottomRow = VAL(BottomRow$)
        IF BottomRow < row OR BottomRow > 24 THEN BottomRow = row

        LINE INPUT " Enter Right column: ", RightCol$
        IF RightCol$ = "" THEN RightCol$ = "80"
        RightCol = VAL(RightCol$)
        IF RightCol > 80 THEN RightCol = 80

        LINE INPUT " Enter desired Character Color Attribute (CCA) to change to: ", CCA$
        IF CCA$ = "" THEN EXIT DO
        CCA = VAL(CCA$)
        IF CCA > 255 THEN EXIT DO

        DReColorArea &HB800, 0, row, col, BottomRow, RightCol, CCA
        NotSave = 1
    END IF
    IF a$ = CHR$(27) THEN EXIT DO
  LOOP


VIEW PRINT 1 TO 25
END SUB

SUB SaveFile

File$ = FileName$
        VIEW PRINT 25 TO 25
        COLOR 0, 7: CLS 2

        f$ = Format$
        PRINT " Save file in which Format [";
        COLOR 4, 7: PRINT "A"; : COLOR 0, 7: PRINT "nsi - Asci";
        COLOR 4, 7: PRINT "i"; : COLOR 0, 7
        PRINT " - "; : COLOR 4, 7: PRINT "H";
        COLOR 0, 7: PRINT "eart]: ";
       SOUND 1500, .5

40      KeyHit a$
        a$ = UCASE$(a$)
        IF a$ = "A" OR a$ = "I" OR a$ = "H" OR a$ = CHR$(27) GOTO 50 ELSE 40
       
50      IF a$ = "A" THEN Format$ = "Ansi"
        IF a$ = "I" THEN Format$ = "Ascii"
        IF a$ = "H" THEN Format$ = "Heart"
        IF a$ = CHR$(27) GOTO EndSUB4
       
        IF Format$ <> f$ THEN d = 0: GOSUB EnterFileName
        IF d = 1 THEN d = 0: FileName$ = File$: GOTO EndSUB4

52      CLS 2
        PRINT " Number of Rows to Save [1 to 24] - (24 default): ";
        SOUND 1500, .5
        COLOR 4, 7: INPUT "", SaveRows$
        IF SaveRows$ = CHR$(27) GOTO EndSUB4
        IF SaveRows$ = "" THEN SaveRows$ = "24"
        SaveRows = VAL(SaveRows$)
        IF SaveRows < 1 OR SaveRows > 24 THEN GOTO 52

53      CLS 2
        COLOR 0, 7
        PRINT " Number of Columns to Save [1 to 80] - (80 default): ";
        SOUND 1500, .5
        COLOR 4, 7: INPUT "", SaveCols$
        IF SaveCols$ = CHR$(27) GOTO EndSUB4
        IF SaveCols$ = "" THEN SaveCols$ = "80"
        SaveCols = VAL(SaveCols$)
        IF SaveCols < 1 OR SaveCols > 80 THEN GOTO 53

        IF Format$ = "Ascii" THEN
              CLS 2: COLOR 0, 7
              PRINT " All Colors will be lost in Ascii. Is this okay [y/N]: ";
              SOUND 1500, .5
              KeyHit a$
              a$ = UCASE$(a$)
              IF a$ <> "Y" GOTO EndSUB4
        END IF
             
 IF FileName$ = "" OR FileName$ = "  No Name!" THEN GOSUB EnterFileName
 IF FileName$ = "" GOTO EndSUB4

 GOSUB PrintSaving
             



'*************************************************************************
              VIEW PRINT 1 TO 25
              i = 1
              OPEN FileName$ FOR OUTPUT AS #1
                  IF Format$ = "Heart" THEN PRINT #1, CHR$(3) + "0";
                  FOR a = 1 TO SaveRows
                      b$ = ""
                      FOR b = 1 TO SaveCols
                          CharOffset = (a - 1) * 160 + (b - 1) * 2
                          ColorOffset = ((a - 1) * 160 + (b - 1) * 2) + 1
                          LOCATE a, b, 1
                          Char = PEEK(CharOffset)
                          CharAttr = PEEK(ColorOffset)
                         
                          '--------------------------------------
                          IF Format$ = "Heart" THEN
                             IF CharAttr = HeartCode(i) THEN
                                    GOTO 65
                             ELSE
                                 IF Char = 32 AND CharAttr = 0 THEN GOTO 65
                                 GOSUB SetHeart
                                 b$ = b$ + a$ + CHR$(Char)
                                 GOTO 66
                             END IF
                          END IF

                          '-------------------------------------
                          IF Format$ = "Ansi" THEN
                             IF Char = 126 THEN STOP
                             IF (CharAttr = AnsActAttr(i)) THEN
                                    GOTO 65
                             ELSE
                                 IF Char = 32 AND CharAttr = 0 THEN GOTO 65
                                 GOSUB SetAnsi
                                 b$ = b$ + a$ + CHR$(Char)
                                 GOTO 66
                             END IF
                          END IF
                          '-------------------------------------

65                        b$ = b$ + CHR$(Char)
66                    NEXT b
                      b$ = RTRIM$(b$)
                      'IF Format$ = "Ansi" THEN GOSUB ProcessSpaces
                      PRINT #1, b$
                  NEXT a
              IF Format$ = "Ansi" THEN PRINT #1, CHR$(27) + "[0m"
              CLOSE #1
              NotSave = 0
        

'***************************************************************************


GOTO EndSUB4



'-----------------------------------------------------------------------
EnterFileName:

60                COLOR 0, 7: CLS
                  PRINT " Please Enter File Name: ";
                  COLOR 4, 7: SOUND 1500, .5
                  INPUT "", FileName$
                  FileName$ = UCASE$(FileName$)
                  IF FileName$ = "" THEN d = 1: RETURN
                  IF LEN(FileName$) > 12 GOTO 60
                  IF LEN(FileName$) > 8 AND LEFT$(RIGHT$(FileName$, 4), 1) <> "." GOTO 60
                  IF LEN(FileName$) < 9 AND LEFT$(RIGHT$(FileName$, 4), 1) <> "." THEN
                       IF Format$ = "Ascii" THEN FileName$ = FileName$ + ".ASC"
                       IF Format$ = "Ansi" THEN FileName$ = FileName$ + ".ANS"
                       IF Format$ = "Heart" THEN FileName$ = FileName$ + ".MNU"
                  END IF
                  Exist FileName$, Found
                  IF Found THEN
                        CLS : COLOR 4, 7
                        PRINT "  "; UCASE$(FileName$); : COLOR 0, 7
                        PRINT " allready exists - Overwrite it? [y/N]";
                        SOUND 800, 2
                        KeyHit a$
                        IF UCASE$(a$) <> "Y" GOTO 60
                  END IF
                  COLOR 0, 7
               
RETURN
'----------------------------------------------------------------------


'----------------------------------------------------------------------
SetHeart:
        a$ = CHR$(3): Match = 0
        FOR i = 1 TO 36
            IF CharAttr = HeartCode(i) THEN
                  a$ = a$ + ActHeartCode$(i)
                  Match = 1
                  EXIT FOR
            END IF
        NEXT i
        IF Match = 0 THEN a$ = a$ + "7"
RETURN
'---------------------------------------------------------------------

'---------------------------------------------------------------------
SetAnsi:
        a$ = "": Previous$ = AnsiCode$(i): i = 1
        DO UNTIL i = 255
            IF CharAttr = AnsActAttr(i) THEN
                  a$ = CHR$(27) + AnsiCode$(i)
                  Match = 1
                  EXIT DO
            END IF
            i = i + 1
        LOOP
        IF INSTR(AnsiCode$, "[1;") > 0 OR INSTR(AnsiCode$, ";1;") > 0 THEN RETURN
        IF INSTR(Previous$, "[1;") > 0 OR INSTR(Previous$, ";1;") > 0 THEN a$ = CHR$(27) + "[0;" + RIGHT$(a$, LEN(a$) - 2)
RETURN
'-------------------------------------------------------------------------

'-------------------------------------------------------------------------
PrintSaving:
         CLS : COLOR 4, 7
         PRINT SPC(36); "Saving....";
         RETURN
'-------------------------------------------------------------------------


'-------------------------------------------------------------------------
ProcessSpaces:
      c = 0: p = 0: d$ = "": e$ = ""
      DO UNTIL p >= LEN(b$)
         p = p + 1
         c$ = MID$(b$, p, 1)
         IF c$ = CHR$(32) THEN c = c + 1: e$ = e$ + c$: GOTO Go13
         IF c > 4 THEN
            c$ = CHR$(27) + "[" + LTRIM$(STR$(c)) + "C" + c$
            c = 0: e$ = ""
         END IF
         IF e$ > "" THEN c$ = e$ + c$: e$ = "": c = 0
         d$ = d$ + c$
Go13: LOOP
      b$ = d$
RETURN
'-------------------------------------------------------------------------



EndSUB4:
   VIEW PRINT 1 TO 25
   COLOR 7, 1
   END SUB

SUB SetAttr (Attr)


ScrSave SavedScreen(), 0, 1
  
UnCalcAttr ForeGround, BackGround, Attr

       COLOR 7, 0: CLS


IF Format$ = "Heart" THEN
      PRINT "Heart  CTRL-P     Description             Heart  CTRL-P       Description"
      PRINT ""
      PRINT " 1 .... (0)   Light Grey on Black     "; : COLOR 7, 0: PRINT "   19 .... "; : COLOR 1, 6: PRINT "(I)   Blue on Brown           "
      COLOR 7, 0: PRINT " 2 .... "; : COLOR 11, 0: PRINT "(1)   Intense Cyan on Black"; : COLOR 7, 0: PRINT "      20 .... "; : COLOR 14, 1: PRINT "(J)   Yellow on Blue          "
      COLOR 7, 0: PRINT " 3 .... "; : COLOR 14, 0: PRINT "(2)   Yellow on Black       "; : COLOR 7, 0: PRINT "     21 .... "; : COLOR 3, 1: PRINT "(K)   Cyan on Blue            "
      COLOR 7, 0: PRINT " 4 .... "; : COLOR 5, 0: PRINT "(3)   Magenta on Black"; : COLOR 7, 0: PRINT "           22 .... "; : COLOR 7, 1: PRINT "(L)   Light Grey on Blue      "
      COLOR 7, 0: PRINT " 5 .... "; : COLOR 15, 1: PRINT "(4)   Intense White on Blue   "; : COLOR 7, 0: PRINT "   23 .... "; : COLOR 7, 5: PRINT "(M)   Light Grey on Magenta   "
      COLOR 7, 0: PRINT " 6 .... "; : COLOR 10, 0: PRINT "(5)   Intense Green on Black"; : COLOR 7, 0: PRINT "     24 .... "; : COLOR 0, 3: PRINT "(N)   Black on Cyan           "
      COLOR 7, 0: PRINT " 7 .... "; : COLOR 12, 0: PRINT "(6)   Intense Red on Black  "; : COLOR 7, 0: PRINT "     25 .... "; : COLOR 0, 7: PRINT "(O)   Black on Light Grey     "
      COLOR 7, 0: PRINT " 8 .... "; : COLOR 9, 0: PRINT "(7)   Intense Blue on Black "; : COLOR 7, 0: PRINT "     26 .... "; : COLOR 4, 7: PRINT "(P)   Red on Light Grey       "
      COLOR 7, 0: PRINT " 9 .... "; : COLOR 6, 0: PRINT "(8)   Brown on Black"; : COLOR 7, 0: PRINT "             27 .... "; : COLOR 1, 7: PRINT "(Q)   Blue on Light Grey      "
      COLOR 7, 0: PRINT "10 .... "; : COLOR 3, 0: PRINT "(9)   Cyan on Black"; : COLOR 7, 0: PRINT "              28 .... "; : COLOR 15, 7: PRINT "(R)   Intense White on Lt Grey"
      COLOR 7, 0: PRINT "11 .... "; : COLOR 2, 0: PRINT "(A)   Green on Black"; : COLOR 7, 0: PRINT "             29 .... "; : COLOR 12, 7: PRINT "(S)   Intense Red on Lt Grey  "
      COLOR 7, 0: PRINT "12 .... "; : COLOR 13, 0: PRINT "(B)   Intense Magenta on Black"; : COLOR 7, 0: PRINT "   30 .... "; : COLOR 9, 7: PRINT "(T)   Intense Blue on Lt Grey "
      COLOR 7, 0: PRINT "13 .... "; : COLOR 15, 4: PRINT "(C)   Intense White on Red    "; : COLOR 7, 0: PRINT "   31 .... "; : COLOR 15, 0: PRINT "(U)   Intense White on Black  "
      COLOR 7, 0: PRINT "14 .... "; : COLOR 14, 4: PRINT "(D)   Yellow on Red           "; : COLOR 7, 0: PRINT "   32 .... "; : COLOR 0, 4: PRINT "(V)   Black on Red            "
      COLOR 7, 0: PRINT "15 .... "; : COLOR 11, 4: PRINT "(E)   Intense Cyan on Red     "; : COLOR 7, 0: PRINT "   33 .... "; : COLOR 0, 1: PRINT "(W)   Black on Blue           "
      COLOR 7, 0: PRINT "16 .... "; : COLOR 7, 4: PRINT "(F)   Light Grey on Red       "; : COLOR 7, 0: PRINT "   34 .... "; : COLOR 0, 5: PRINT "(X)   Black on Magenta        "
      COLOR 7, 0: PRINT "17 .... "; : COLOR 1, 2: PRINT "(G)   Blue on Green           "; : COLOR 7, 0: PRINT "   35 .... "; : COLOR 15, 2: PRINT "(Y)   Intense White on Green  "
      COLOR 7, 0: PRINT "18 .... "; : COLOR 4, 6: PRINT "(H)   Red on Brown            "; : COLOR 7, 0: PRINT "   36 .... "; : COLOR 15, 3: PRINT "(Z)   Intense White on Cyan   "
    
      COLOR 7, 0
      PRINT ""
     
      COLOR ForeGround, BackGround: LOCATE 22, 32
      PRINT " Current Attribute "
    
      COLOR 14, 0: PRINT
      PRINT "Enter New Heart Code Color Attribute [1 to 36]: ";
      COLOR 15, 0
      INPUT "", BB
      IF BB < 1 OR BB > 36 OR BB = 0 GOTO EndSUB3
      Attr = HeartCode(BB)
      GOTO EndSUB3
END IF


IF Format$ = "Ansi" OR Format$ = "Ascii" THEN
     LOCATE 2, 34: COLOR 14, 0: PRINT "Foreground"
     LOCATE 4, 20
     COLOR 0, 7: PRINT "0"; : COLOR 1, 0: PRINT " 1"; : COLOR 2, 0: PRINT " 2 ";
     COLOR 3, 0: PRINT "3"; : COLOR 4, 0: PRINT " 4"; : COLOR 5, 0: PRINT " 5 ";
     COLOR 6, 0: PRINT "6"; : COLOR 7, 0: PRINT " 7"; : COLOR 8, 0: PRINT " 8 ";
     COLOR 9, 0: PRINT "9"; : COLOR 10, 0: PRINT " 10"; : COLOR 11, 0: PRINT " 11 ";
     COLOR 12, 0: PRINT "12"; : COLOR 13, 0: PRINT " 13"; : COLOR 14, 0: PRINT " 14";
     COLOR 15, 0: PRINT " 15"

     LOCATE 6, 15
     COLOR 16, 7: PRINT "16"; : COLOR 17, 0: PRINT " 17"; : COLOR 18, 0: PRINT " 18 ";
     COLOR 19, 0: PRINT "19"; : COLOR 20, 0: PRINT " 20"; : COLOR 21, 0: PRINT " 21 ";
     COLOR 22, 0: PRINT "22"; : COLOR 23, 0: PRINT " 23"; : COLOR 24, 0: PRINT " 24 ";
     COLOR 25, 0: PRINT "25"; : COLOR 26, 0: PRINT " 26"; : COLOR 27, 0: PRINT " 27 ";
     COLOR 28, 0: PRINT "28"; : COLOR 29, 0: PRINT " 29"; : COLOR 30, 0: PRINT " 30";
     COLOR 31, 0: PRINT " 31"

     LOCATE 9, 34: COLOR 14, 0: PRINT "Background"
     LOCATE 11, 31
     COLOR 0, 7: PRINT "0"; : COLOR 1, 0: PRINT " 1"; : COLOR 2, 0: PRINT " 2 ";
     COLOR 3, 0: PRINT "3"; : COLOR 4, 0: PRINT " 4"; : COLOR 5, 0: PRINT " 5 ";
     COLOR 6, 0: PRINT "6"; : COLOR 7, 0: PRINT " 7"

     COLOR 2, 0: PRINT : PRINT "                         Ŀ"
                         PRINT "                                                   "
                         PRINT "                                                   "
                         PRINT "                                                   "
                         PRINT "                         "
     LOCATE 14, 30: COLOR ForeGround, BackGround: PRINT " Current Attribute "
     COLOR 14, 0
     LOCATE 16, 29
     PRINT "Fore: "; ForeGround; "    Back: "; BackGround
   
102  COLOR 7, 0
     LOCATE 20, 20: PRINT "Enter Foreground [0 to 31]:          "
     LOCATE 22, 20: PRINT "Enter Background [0 to 7] :          "
     LOCATE 20, 48: COLOR 15, 0
     INPUT "", Fore$
     IF LEN(Fore$) > 2 GOTO 102
     IF Fore$ = "" THEN Fore = ForeGround
     IF Fore$ > "" THEN Fore = VAL(Fore$)
     IF Fore < 0 OR Fore > 31 GOTO 102

104  LOCATE 22, 48: PRINT "                             "
     LOCATE 22, 48: COLOR 15, 0
     INPUT "", Back$
     IF LEN(Back$) > 1 GOTO 104
     IF Back$ = "" THEN Back = BackGround
     IF Back$ > "" AND LEN(Back$) < 2 THEN Back = VAL(Back$)
     IF Back < 0 OR Back > 7 GOTO 104


     CalcAttr Fore, Back, Attr

END IF



EndSUB3:
      ScrRest SavedScreen(), 0, 1
      COLOR 7, 1
      END SUB

SUB SetKeySpeed STATIC

          VIEW PRINT 25 TO 25
          COLOR 0, 7: CLS 2
          SOUND 2500, 2
          PRINT " Enter delay before starting to repeat a key - [0 to 3]: ";
          COLOR 4, 7
          PRINT RepDelay$;
          LOCATE 25, 58
          LINE INPUT "", a$
          IF a$ = "" THEN a$ = RepDelay$
          RepDelay$ = a$
          RepDelay = VAL(RepDelay$)
          IF RepDelay < 0 OR RepDelay > 3 THEN RepDelay = 1: RepDelay$ = "1"
          COLOR 0, 7: CLS 2
          SOUND 2500, 2
          PRINT " Enter rate at which to repeat a key - [0 to 31]: ";
          COLOR 4, 7
          PRINT RepRate$;
          LOCATE 25, 51
          LINE INPUT "", a$
          IF a$ = "" THEN a$ = RepRate$
          RepRate$ = a$
          RepRate = VAL(RepRate$)
          IF RepRate < 0 OR RepRate > 31 THEN RepRate = 11: RepRate$ = "11"

     SpeedKey RepDelay, RepRate

EndSUB233:
      VIEW PRINT 1 TO 25
      END SUB

SUB SetTab (TabSpace)

T = TabSpace

VIEW PRINT 25 TO 25
COLOR 0, 7: CLS
SOUND 2000, 2
PRINT " Enter new TAB space: ";
INPUT "", TabSpace
IF TabSpace > 79 THEN TabSpace = 79
IF TabSpace < 1 THEN TabSpace = T

VIEW PRINT 1 TO 25
COLOR 7, 1:

END SUB

SUB StringScroll (Strg$, StrgStart%, StrgRow%, ScrlTime%, StrgPause%, StrgWrap%, StrgPasses%, StrgStopLoc%, StrgMultCol%, StrgBackCol%, ExitKey$)


IF ScrlTime < 1 THEN ScrlTime = 1
IF LEN(Strg$) > 79 THEN ErrCode = 1: GOTO ScrollError
p = INT(40 - (LEN(Strg$) / 2) - 2)
IF StrgStopLoc > 0 THEN
        IF StrgStopLoc > 80 - LEN(Strg$) THEN
                StrgStopLoc = 80 - LEN(Strg$)
        END IF
        p = StrgStopLoc
END IF

StrgPass = 0
IF StrgMultCol > -1 THEN cl = StrgMultCol
COLOR cl, StrgBackCol
IF StrgBackCol > 0 THEN LOCATE StrgRow, 1: PRINT STRING$(80, CHR$(255));



StartScroll:

'******  From Right Side of Screen  ******

IF StrgStart = 0 THEN
        col = 80: a$ = ""
IF StrgStart = 1 THEN col = 1
      
     LOCATE StrgRow, col

FOR x = 1 TO LEN(Strg$)
        Char = ASC(LEFT$(MID$(Strg$, x), 1))
        a$ = a$ + CHR$(Char)
        LOCATE StrgRow, col: PRINT a$;
        col = col - 1
        IF StrgMultCol = -1 THEN cl = cl + 1: COLOR cl, StrgBackCol: IF cl > 15 OR cl = 0 THEN cl = 1: COLOR cl, StrgBackCol
        FOR T = 1 TO ScrlTime
                Key$ = INKEY$
                IF Key$ > "" GOTO ScrollError
        NEXT T
NEXT x


PassTwoForWrap:
FOR a = 1 TO 80 - LEN(Strg$)
        LOCATE StrgRow, col + LEN(Strg$): PRINT CHR$(32)
        LOCATE StrgRow, col: PRINT Strg$;
        col = col - 1
        IF StrgMultCol = -1 THEN cl = cl + 1: COLOR cl, StrgBackCol: IF cl > 15 OR cl = 0 THEN cl = 1: COLOR cl, StrgBackCol
        FOR T = 1 TO ScrlTime
                Key$ = INKEY$
                IF Key$ > "" GOTO ScrollError
        NEXT T
        IF col = p AND StrgPause > 0 THEN
                IF StrgStopLoc > 0 AND col = StrgStopLoc GOTO ScrollError
                IF StrgStopLoc = -1 THEN GOTO ScrollError
                SLEEP StrgPause
        END IF
NEXT a

col = col + LEN(Strg$)
a$ = Strg$: b$ = ""

FOR x = LEN(Strg$) - 1 TO 1 STEP -1
        a$ = RIGHT$(a$, x)
        LOCATE StrgRow, 1: PRINT CHR$(32)
        LOCATE StrgRow, 1: PRINT a$
        LOCATE StrgRow, LEN(a$) + 1: PRINT CHR$(32)
        IF StrgPass < StrgPasses - 1 OR StrgPasses <= 0 THEN
        IF StrgWrap = 1 THEN
                b$ = LEFT$(Strg$, LEN(Strg$) - x)
                LOCATE StrgRow, 80 - LEN(b$): PRINT b$
        END IF
        END IF
        IF StrgMultCol = -1 THEN cl = cl + 1: COLOR cl, StrgBackCol: IF cl > 15 OR cl = 0 THEN cl = 1: COLOR cl, StrgBackCol
        FOR T = 1 TO ScrlTime
                Key$ = INKEY$
                IF Key$ > "" GOTO ScrollError
        NEXT T
NEXT x

LOCATE StrgRow, 1: PRINT CHR$(32)


IF StrgPasses <= 0 THEN
        IF StrgWrap = 1 THEN col = 80 - LEN(Strg$): GOTO PassTwoForWrap
        GOTO StartScroll
END IF


IF StrgPass = StrgPasses - 1 THEN GOTO ScrollError

IF StrgWrap = 1 THEN
        col = 80 - LEN(Strg$)
        IF StrgPasses > 0 THEN StrgPass = StrgPass + 1
        GOTO PassTwoForWrap
END IF
StrgPass = StrgPass + 1
GOTO StartScroll
END IF



'******  From Left Side of Screen  ******
IF StrgStart = 1 THEN

l = 80 - LEN(Strg$): m = LEN(Strg$)

a$ = "": col = 1: p = INT(40 - (LEN(Strg$) / 2))

IF StrgStopLoc > 0 THEN
        IF StrgStopLoc + LEN(Strg$) > 79 THEN StrgStopLoc = (79 - LEN(Strg$))
        p = StrgStopLoc
END IF
FOR x = m TO 1 STEP -1
        Char = ASC(LEFT$(MID$(Strg$, x), 1))
        a$ = a$ + CHR$(Char)
        b$ = a$ + b$: a$ = ""
        LOCATE StrgRow, 1: PRINT b$;
        IF StrgMultCol = -1 THEN cl = cl + 1: COLOR cl, StrgBackCol: IF cl > 15 OR cl = 0 THEN cl = 1: COLOR cl, StrgBackCol
        FOR T = 1 TO ScrlTime
                Key$ = INKEY$
                IF Key$ > "" GOTO ScrollError
        NEXT T
NEXT x

PassTwoForWrapLeft:
col = 0

FOR a = 1 TO l
        IF StrgStopLoc = 1 THEN col = 1
        IF col = p AND StrgPause > 0 THEN
                IF StrgStopLoc > 0 AND col = StrgStopLoc GOTO ScrollError
                IF StrgStopLoc = -1 THEN GOTO ScrollError
                SLEEP StrgPause
        END IF
        col = col + 1
        a$ = a$ + CHR$(32)
        c$ = a$ + b$
        LOCATE StrgRow, 1: PRINT c$;
        IF StrgMultCol = -1 THEN cl = cl + 1: COLOR cl, StrgBackCol: IF cl > 15 OR cl = 0 THEN cl = 1: COLOR cl, StrgBackCol
        FOR T = 1 TO ScrlTime
                Key$ = INKEY$
                IF Key$ > "" GOTO ScrollError
        NEXT T
     

NEXT a

b$ = "": a$ = ""


FOR x = m TO 1 STEP -1
        Char = ASC(LEFT$(MID$(Strg$, x), 1))
        a$ = a$ + CHR$(Char)
        b$ = a$ + b$: a$ = ""
        IF StrgWrap = 0 THEN c$ = CHR$(32) + c$: c$ = LEFT$(c$, LEN(c$) - 1): LOCATE StrgRow, 1: PRINT c$: GOTO 20
        c$ = CHR$(32) + c$: c$ = LEFT$(c$, LEN(c$) - 1): LOCATE StrgRow, 1: PRINT c$;
        LOCATE StrgRow, 1: PRINT b$;
20      FOR T = 1 TO ScrlTime
                Key$ = INKEY$
                IF Key$ > "" GOTO ScrollError
        NEXT T
        IF StrgMultCol = -1 THEN cl = cl + 1: COLOR cl, StrgBackCol: IF cl > 15 OR cl = 0 THEN cl = 1: COLOR cl, StrgBackCol
NEXT x

IF StrgWrap = 0 THEN b$ = ""
a$ = "": col = 1


IF StrgPasses <= 0 THEN
        IF StrgWrap = 1 GOTO PassTwoForWrapLeft
        GOTO StartScroll
END IF


IF StrgPass = StrgPasses - 1 THEN GOTO ScrollError

IF StrgWrap = 1 THEN
        col = 1
        IF StrgPasses > 0 THEN StrgPass = StrgPass + 1
        GOTO PassTwoForWrapLeft
END IF
StrgPass = StrgPass + 1
GOTO StartScroll

END IF



ScrollError:
          ExitKey$ = Key$
          END SUB

